
public class MRCoordinate {
	//----------萔------------
	static final int DEF_EDGE_HEIGHT=4;
	//(sbsToCrd[][],crdToSbsEdge,dragPos)
	static final int CO_HOR=0;	//=MRPanel.DRG_POS_HOR
	static final int CO_VER=1;	//=MRPanel.DRG_POS_VER
	static final int CO_ALL=2;
	//(crdToSbsEdge[][])
	static final int EDG_ELM=0;
	static final int EDG_ITM=1;
	static final int EDG_ALL=2;
	//(crdToSbsCent[][])
	static final int SBS_HOR_ELM=0;
	static final int SBS_HOR_ITM=1;
	static final int SBS_VER_ELM=2;
	static final int SBS_VER_ITM=3;
	static final int SBS_ALL=4;
	//
	//----------ϐ------------
	//pYf[^iŜ̃TCY\ʒǔɕKvj
	MRData data;
	//
	int edgeHeight;
	int edgeWidth;
	//
	//e(substance)W(coordinate)ւ̕ϊ
	int[/*elemNum*/][/*itemNum*/][/*CO_ALL*/] sbsToCrd;
	//
	//W(coordinate)e(substance)ւ̕ϊ
	int[/*egeWidth*/][/*edgeWidth*/][/*SBS_ALL*/] crdToSbsCent;
	int[/*CO_ALL*/][/*edgeWidth*/][/*EDG_ALL*/] crdToSbsEdge;
	//
	int dragPos;	//drag̗̈攻Ɏg
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public MRCoordinate(MRData d){
		//
		data=d;
		//
		edgeHeight=DEF_EDGE_HEIGHT;
		edgeWidth=data.getEdgeWidth();
		//ϊe[u쐬
		setCoordinate();
	}
	//******************************************************************************************************
	//ϊe[u
	//------------------------------------------------------------------------------------------------------
	public void setCoordinate(){
		//
		int hn,vn;
		//***Substance to Coordinate
		sbsToCrd=new int[data.elemNum][data.itemNum][CO_ALL];
		for(int i=0;i<data.itemNum;i++){
			sbsToCrd[0][i][CO_HOR]=MRData.NO_DATA;	//0
		}
		hn=0;
		for(int e=1;e<data.elemNum;e++){
			for(int i=0;i<data.itemNum;i++){
				sbsToCrd[e][i][CO_HOR]=hn;			//1-
				hn++;
			}
		}
		vn=0;
		for(int i=0;i<data.itemNum;i++){
			sbsToCrd[0][i][CO_VER]=vn;				//0
			sbsToCrd[1][i][CO_VER]=MRData.NO_DATA;	//1
			vn++;
		}
		for(int e=data.elemNum-1;e>1;e--){
			for(int i=0;i<data.itemNum;i++){
				sbsToCrd[e][i][CO_VER]=vn;			//-2
				vn++;
			}
		}
		//***Coordinate to Substance on edge
		crdToSbsEdge=new int[CO_ALL][edgeWidth][EDG_ALL];
		hn=0;
		for(int e=1;e<data.elemNum;e++){	//1-
			for(int i=0;i<data.itemNum;i++){
				crdToSbsEdge[CO_HOR][hn]=new int[]{e,i};
				hn++;
			}
		}
		vn=0;
		for(int i=0;i<data.itemNum;i++){
			crdToSbsEdge[CO_VER][vn]=new int[]{0,i};
			vn++;
		}
		for(int e=data.elemNum-1;e>1;e--){
			for(int i=0;i<data.itemNum;i++){
				crdToSbsEdge[CO_VER][vn]=new int[]{e,i};
				vn++;
			}
			//
		}
		//***Coordinate to Substance on center
		crdToSbsCent=new int[edgeWidth][edgeWidth][SBS_ALL];
		for(int w=0;w<edgeWidth;w++){
			for(int h=0;h<edgeWidth;h++){
				crdToSbsCent[w][h]=null;
			}
		}
		hn=0;
		vn=0;
		for(int vi=0;vi<data.itemNum;vi++){
			for(int he=1;he<data.elemNum;he++){	//1-
				for(int hi=0;hi<data.itemNum;hi++){
					crdToSbsCent[hn][vn]=new int[]{he,hi,0,vi};
					hn++;
				}
			}
			//
			hn=0;
			vn++;
		}
		//hn=0;
		//vn++;
		for(int ve=data.elemNum-1;ve>1;ve--){
			for(int vi=0;vi<data.itemNum;vi++){
				for(int he=1;he<data.elemNum;he++){	//1-
					//
					if(he>=ve){
						break;	//
					}
					//
					for(int hi=0;hi<data.itemNum;hi++){
						crdToSbsCent[hn][vn]=new int[]{he,hi,ve,vi};
						hn++;
					}
				}
				//
				hn=0;
				vn++;
			}
		}
	}
	//******************************************************************************************************
	//}XʒuΏۗvf𔻒
	//------------------------------------------------------------------------------------------------------
	//
	public int[] getSubstance(int x,int y) {
		//͈͊O
		if(x<-edgeHeight || x>=edgeWidth || y<-edgeHeight || y>=edgeWidth){
			return null;
		}
		//͈͓
		if(y>=0){
			if(x>=0){		//center
				return crdToSbsCent[x][y];		//null̂Ƃ
			}else{			//edge(vertical)
				dragPos=CO_VER;		//paneldrag̗̈攻Ɏg
				return crdToSbsEdge[CO_VER][y];
			}
		}else{
			if(x>=0){		//edge(horizontal)
				dragPos=CO_HOR;		//paneldrag̗̈攻Ɏg
				return crdToSbsEdge[CO_HOR][x];
			}else{			//̋󗓕
				return null;
			}
		}
	}
}
