import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class MRSaveDialog extends JDialog implements ActionListener {
	//----------萔------------
	//Editor
	static final String NAME_HINT_TXT="_txt.txt";
	static final String NAME_HINT_IMG="_img.png";
	//Player
	static final String NAME_SOLUTION="_sol.csv";
	//----------ϐ------------
	//Ăяo
	MRFrame frame;
	MRFileIO fileIO;
	//
	File filePoint;
	//
	JTextField fieldTable=new JTextField(18);
	JTextField fieldHintTxt=new JTextField(18);
	JTextField fieldHintImg=new JTextField(18);
	//
	JButton buttonFile=new JButton("I");
	JButton buttonOk=new JButton("ۑ");
	JButton buttonCancel=new JButton("");
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public MRSaveDialog(MRFrame frm,MRFileIO fIO){
		super(frm,"Otĕۑ",true);
		frame=frm;
		fileIO=fIO;
		//
		fieldTable.setEditable(false);
		fieldHintTxt.setEditable(false);
		fieldHintImg.setEditable(false);
		//1-1
		JPanel panelSavaPoint=new JPanel();
		panelSavaPoint.add(new JLabel("OX\(Matrix)E𓚕\F"));
		panelSavaPoint.add(fieldTable);
		panelSavaPoint.add(buttonFile);
		//1-2
		JPanel panelSavaDraw=new JPanel();
		panelSavaDraw.add(new JLabel("qgeLXgF"));
		panelSavaDraw.add(fieldHintTxt);
		//1-3
		JPanel panelSaveBack=new JPanel();
		panelSaveBack.add(new JLabel("qg摜F"));
		panelSaveBack.add(fieldHintImg);
		//1
		JPanel panelSave=new JPanel();
		panelSave.setLayout(new GridLayout(3,1));
		panelSave.add(panelSavaPoint);
		panelSave.add(panelSavaDraw);
		panelSave.add(panelSaveBack);
		//2
		JPanel panelBtn=new JPanel();
		panelBtn.add(buttonOk);
		panelBtn.add(buttonCancel);
		//
		//Reig
		Container cp=getContentPane();
		cp.add(panelSave,BorderLayout.CENTER);
		cp.add(panelBtn,BorderLayout.SOUTH);
		//
		buttonFile.addActionListener(this);
		buttonOk.addActionListener(this);
		buttonCancel.addActionListener(this);
		//
		pack();							//TCYāǍ
		setLocationRelativeTo(null);	//ʂ̐^񒆂ɕ\
	}
	//******************************************************************************************************
	//{^Cxg
	//------------------------------------------------------------------------------------------------------
	public void actionPerformed(ActionEvent e) {
		Object object=e.getSource();
		if(object==buttonFile){
			//
			fileIO.getTrifileInfo(this);
		}else if(object==buttonOk){
			setVisible(false);
			//
			fileIO.saveTrifile(frame.puzzleField);
		}else if(object==buttonCancel){
			setVisible(false);
		}
	}
	//******************************************************************************************************
	// uRt@CviCSVAhintTextAhintImagej̃t@C\
	//------------------------------------------------------------------------------------------------------
	public void setTrifileInfo(File svF){
		//
		if(svF==null){
			fieldTable.setText("");
			fieldHintTxt.setText("");
			fieldHintImg.setText("");
			//
			buttonOk.setEnabled(false);
		}else{
			fieldTable.setText(svF.getPath());
			fieldHintTxt.setText(convertFileName(svF, NAME_HINT_TXT).getName());
			fieldHintImg.setText(convertFileName(svF, NAME_HINT_IMG).getName());
			//
			buttonOk.setEnabled(true);
		}
	}
	//******************************************************************************************************
	// C̕ۑt@CiCSVj̃t@CA̕ۑt@CihintTextAhintImagej̃t@C擾
	//------------------------------------------------------------------------------------------------------
	public static File convertFileName(File file,String adName){
		//
		int period=file.getPath().lastIndexOf(".");
		if(period!=-1){
			return new File(file.getPath().substring(0,period)+adName);
		}else{	//
			return new File(file.getPath()+adName);
		}
	}
}
