import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.print.PageFormat;
import java.awt.print.Printable;
import java.awt.print.PrinterException;

import javax.swing.JComboBox;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

public class MRAnswerTablePanel extends JPanel implements FocusListener,ActionListener,MouseListener, ComponentListener, Printable, ImageOutputable{
	//----------萔------------
	//
	//----------ϐ------------
	//
	MRFrame frame;
	MRData data;
	//
	int baseX,baseY;
	int cellSize;
	//f[^Ip
	JComboBox<String> comboItem=new JComboBox<String>();
	int tmpE,tmpI;	//ꎞIɑIΏۂi[
	//\̍̕W
	int[/*elemNum+1*/] posX;
	//
	//t[TCŶ
	JScrollPane scrollEdge;
	Dimension edgeMargin;
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public MRAnswerTablePanel(MRFrame frm,MRData dat){
		frame=frm;
		data=dat;
		//
		cellSize=MRPanel.DEF_CELL;
		//
		setLayout(null);	//ꂪȂJComboBox.setBounds()LɂȂȂ
		add(comboItem);
		comboItem.setVisible(false);
		tmpE=MRData.NO_DATA;
		tmpI=MRData.NO_DATA;
		//
		comboItem.addFocusListener(this);
		comboItem.addActionListener(this);
		addMouseListener(this);
		addComponentListener(this);
		//
		refreshViewAll();
	}
	//t[TCŶ߃XN[̈Ƃ̃TCY߂˂΂Ȃ
	public void setScrollEdge(JScrollPane scroll){
		scrollEdge=scroll;
		//
		edgeMargin=new Dimension(scrollEdge.getWidth()-getWidth(),scrollEdge.getHeight()-getHeight());
		if(edgeMargin.width==0 || edgeMargin.height==0){
			edgeMargin=new Dimension(3,3);		//炩̗RœȂWindowsł̒lɐݒ
		}
	}
	//******************************************************************************************************
	// VKEύX
	//------------------------------------------------------------------------------------------------------
	public void refreshViewAll(){		//\̑SĂ̕ČvZ
		posX=new int[data.elemNum+1];
		posX[0]=0;
		//element 0(ansTypep̕)(typenull̏ꍇ`FbN)
		posX[1]=posX[0]+data.elems[0].getLongestItemNameSize(cellSize,true,data.getLongestTypeWordSize())+1/*combo*/;
		//element 1-
		for(int e=1;e<data.elemNum;e++){	//1-
			posX[e+1]=posX[e]+data.elems[e].getLongestItemNameSize(cellSize,true,0)+1/*combo*/;	//element name܂Ŋ܂߂
		}
		//W̍Đݒ
		setPreferredPanelSize();
	}
	public void refreshView(int eN){	//\̎w肳ꂽelement̂̕ݍČvZ
		//
		int dL;
		if(eN==0){			//element 0(ansTypep̕)(typenull̏ꍇ`FbN)
			dL=data.elems[eN].getLongestItemNameSize(cellSize,true,data.getLongestTypeWordSize())+1/*combo*/-(posX[eN+1]-posX[eN]);
		}else{				//element 1-
			dL=data.elems[eN].getLongestItemNameSize(cellSize,true,0)+1/*combo*/-(posX[eN+1]-posX[eN]);
		}
		//welementȍ~𑝂₷
		for(int e=eN;e<data.elemNum;e++){
			posX[e+1]+=dL;
		}
		//W̍Đݒ
		setPreferredPanelSize();
	}
	//******************************************************************************************************
	//}XTCY
	//------------------------------------------------------------------------------------------------------
	public void setCellSize(int size){
		cellSize=size;
		//
		setPreferredPanelSize();
	}
	//}XTCYύXɃt[Ă΂AꎞIɃpl̃TCY}X̃TCYɍ킹i܂t[̃TCY͕ςj
	public void adjustPanelSize(){
		//XN[o[\Ă	[XN[̈pl]<[œKplTCY]
		//Ȃ							[XN[̈pl]>[œKplTCY]
		int w=Math.max(scrollEdge.getWidth()-edgeMargin.width,getPreferredSize().width);
		int h=Math.max(scrollEdge.getHeight()-edgeMargin.height,getPreferredSize().height);
		//pl̃TCYύXiXN[̈pl傫ȂΎŃXN[o[oj
		setSize(w,h);
	}
	//******************************************************************************************************
	//œKTCYE`挴_̒
	//------------------------------------------------------------------------------------------------------
	//œKplTCYݒ
	private void setPreferredPanelSize(){
		int preferredWidth=cellSize*(posX[posX.length-1]+2 );	//+2(̓}[W)
		int preferredHeight=cellSize*(data.itemNum+1+2 );		//+1(element name)+2(̓}[W)
		setPreferredSize(new Dimension(preferredWidth,preferredHeight));
		//`挴_ݒ
		setPaintBasePoint();
	}
	//`挴_iplTCYύXPƂŌĂ΂j
	private void setPaintBasePoint(){
		//
		Dimension d=getPreferredSize();
		if(getWidth()<=d.width){
			baseX=(cellSize);
		}else{
			baseX=(cellSize)+( (getWidth()-d.width)>>1 );
		}
		if(getHeight()<=d.height){
			baseY=(cellSize*(1+1));
		}else{
			baseY=(cellSize*(1+1))+( (getHeight()-d.height)>>1 );
		}
		//ōĕ`悷̂őł͂ȂĂ
		repaint();
	}
	//œKplTCYɑ΂āApl̕\Ă镔ǂꂾTCYߏ肩Ԃ
	//it[Ă΂At[ǂꂾ߂΃XN[o[\ɂނ̔fɎgj
	public Dimension getSizeDifference(){
		//XN[o[\Ă	[pl̈]>[XN[̈pl]
		//Ȃ							[pl̈]<[XN[̈pl]
		int w=Math.min(getWidth(),scrollEdge.getWidth()-edgeMargin.width)-getPreferredSize().width;
		int h=Math.min(getHeight(),scrollEdge.getHeight()-edgeMargin.height)-getPreferredSize().height;
		return new Dimension( w , h );
	}
	//摜ۑ̂߂̕`挴_ił͕`XP[ς\̂ňČvZj
	private Point getOutputBasePoint(int cell){
		return new Point(cell*(1),cell*(1+1));
	}
	//******************************************************************************************************
	//`
	//------------------------------------------------------------------------------------------------------
	public void paintComponent(Graphics g){
		super.paintComponent(g);	//KviꂪȂƔwiFœhԂȂj
		//`挴_w肵ĕ`悳
		paintField(g,baseX,baseY,cellSize);
	}
	//摜ۑ̕`i`挴_͕\ɋl߂WA`XP[͓j
	public void paintGraphic(Graphics g){
		Point base=getOutputBasePoint(cellSize);
		paintField(g, base.x, base.y,cellSize);
	}
	//̕`i`挴_͕\ɋl߂WA`XP[͈\̈ɍ킹ďkj
	public int print(Graphics g, PageFormat fmt, int index) throws PrinterException {
		if(index>0){	//y[W1y[WɌŒ
			return NO_SUCH_PAGE;
		}else{
			//\ȍʒu
			int x=(int)fmt.getImageableX();
			int y=(int)fmt.getImageableY();
			g.translate(x,y);
			//`XP[𒲐
			double pageW=fmt.getImageableWidth();
			double pageH=fmt.getImageableHeight();
			int fieldW=getPreferredSize().width;
			int fieldH=getPreferredSize().height;
			double ratioW=pageW/fieldW;		//̔{
			double ratioH=pageH/fieldH;		//̔{
			double ratio=1;
			int cell;
			if(ratioW<1 || ratioH<1){		//ƍǂ炩łk̕Kv
				ratio=(ratioW<ratioH)?ratioW:ratioH;	//k˂΂ȂȂ{I
				//
				cell=(int)(cellSize*ratio);
			}else{							//Sk̕KvȂ΂̂܂
				cell=cellSize;
			}
			//
			Point base=getOutputBasePoint(cell);	//k`XP[Ŏ擾
			paintField(g,base.x,base.y,cell);
			//
			return PAGE_EXISTS;
		}
	}
	//ėp̕`惁\bhi摜ۑɂgj
	private void paintField(Graphics g,int bx,int by,int cell){
		g.setFont(new Font( null, Font.PLAIN, cell-MRPanel.DEF_FONT_DIFF*2));
		//
		//----------------------------wi
	    g.setColor(Color.white);
		g.fillRect(bx-cell, by-cell*(1+1), getPreferredSize().width, getPreferredSize().height);
	    //----------------------------
	    g.setColor(Color.black);
	    g.drawRect(bx-1, by-cell-1, cell*posX[posX.length-1]+2, cell*(data.itemNum+1)+2);
	    g.drawRect(bx, by-cell, cell*posX[posX.length-1], cell-1);
	    g.drawRect(bx, by, cell*posX[posX.length-1], cell*(data.itemNum));
	    for(int v=1;v<posX.length-1;v++){
	    	g.drawLine(bx+cell*posX[v], by-cell, bx+cell*posX[v], by+cell*data.itemNum);
	    }
	    for(int h=1;h<data.itemNum;h++){
	    	g.drawLine(bx, by+cell*h, bx+cell*posX[posX.length-1], by+cell*h);
	    }
	    //----------------------------element 0(łŒ)(ansTypeΕ\)
	    g.drawString(data.elems[0].elemName, bx+MRPanel.DEF_FONT_DIFF, by-MRPanel.DEF_FONT_DIFF);
	    for(int i=0;i<data.itemNum;i++){
	    	g.drawString(data.elems[0].getItem(i/*,MRElement.ITEM_EDIT_ANS*/)+data.getAnsTypeWord(i), bx+MRPanel.DEF_FONT_DIFF, by+cell*(i+1)-MRPanel.DEF_FONT_DIFF);
	    }
	    //----------------------------element 1-(MRDataansTable\)
	    for(int e=1;e<data.elemNum;e++){
		    g.drawString(data.elems[e].elemName, bx+cell*posX[e]+MRPanel.DEF_FONT_DIFF, by-MRPanel.DEF_FONT_DIFF);
		    for(int i=0;i<data.itemNum;i++){
		    	int ans=data.getAns(i, e);
		    	if(ans==MRData.NO_DATA){
			    	g.drawString("-", bx+cell*posX[e]+MRPanel.DEF_FONT_DIFF, by+cell*(i+1)-MRPanel.DEF_FONT_DIFF);
		    	}else{
			    	g.drawString(data.elems[e].getItem(ans/*,MRElement.ITEM_EDIT_ANS*/), bx+cell*posX[e]+MRPanel.DEF_FONT_DIFF, by+cell*(i+1)-MRPanel.DEF_FONT_DIFF);
		    	}
		    }
	    }
		//----------------------------G[
		if(frame.puzzleField.errorViewFlag){
			g.setColor(Color.red);
			//
			for(int e=0;e<data.errors.size();e++){
				MRError er=data.errors.get(e);
				if(er.agreeAnswerError()){
					//ER_ANSWER_OVERLAP
					for(int i=0;i<data.itemNum;i++){
						if(er.ansItems[i]){
							drawErrorRect(g,bx,by,cell,i,er.ansElem,false);
						}
					}
				}else if(er.agreeAnswerContradiction()){
					//CONTRA_ANS_???
					drawErrorRect(g,bx,by,cell,er.itemSV,er.elemSV,true);
					drawErrorRect(g,bx,by,cell,er.itemLH,er.elemLH,true);
				}
			}
		}
	}
	private void drawErrorRect(Graphics g,int bx,int by,int cell,int iN,int eN,boolean roundFlag){
		if(roundFlag){
			g.drawRoundRect(bx+cell*posX[eN]+1,by+cell*iN+1,cell*(posX[eN+1]-posX[eN])-2,cell-2,cell,cell);
			g.drawRoundRect(bx+cell*posX[eN]+2,by+cell*iN+2,cell*(posX[eN+1]-posX[eN])-4,cell-4,cell,cell);
		}else{
			g.drawRect(bx+cell*posX[eN]+1,by+cell*iN+1,cell*(posX[eN+1]-posX[eN])-2,cell-2);
			g.drawRect(bx+cell*posX[eN]+2,by+cell*iN+2,cell*(posX[eN+1]-posX[eN])-4,cell-4);
		}
	}
	//******************************************************************************************************
	//f[^͗p
	//------------------------------------------------------------------------------------------------------
	public void actionPerformed(ActionEvent e) {
		//
		if(e.getSource()==comboItem){
			if(comboItem.isVisible()){	//
				comboItem.setVisible(false);
			}else{						//\̊ԂɔĂi炵jCxgł͉Ȃ
				return;
			}
			//Iꂽf[^𓖂Ă͂
			if(tmpE==0){	//element 0(ansType)
				data.setAnsType(tmpI, comboItem.getSelectedIndex()-1);		//-1
			}else{			//element 1-
				data.setAns(tmpI, tmpE, comboItem.getSelectedIndex()-1);	//-1
			}
			//ύX
			frame.puzzleField.setChanged(true);
			//
			repaint();
			//𓚂\ȂOX\iMatrixjĕ`悹˂΂ȂȂ
			frame.puzzleField.repaint();
		}
	}
	//******************************************************************************************************
	//tH[JXCxg
	//------------------------------------------------------------------------------------------------------
	public void focusGained(FocusEvent arg0) {
	}
	public void focusLost(FocusEvent e) {
		//f[^͗tH[JXΉB
		if(e.getSource()==comboItem){
			comboItem.setVisible(false);
		}
	}
	//******************************************************************************************************
	//}EXCxg
	//------------------------------------------------------------------------------------------------------
	public void mouseClicked(MouseEvent e) {
		//}Xʒu
		int x=(e.getX()>baseX)?(e.getX()-baseX)/cellSize:(e.getX()-cellSize-baseX)/cellSize;
		int y=(e.getY()>baseY)?(e.getY()-baseY)/cellSize:(e.getY()-cellSize-baseY)/cellSize;
		//͈͊O
		if(x<posX[0] || x>=posX[posX.length-1] || y<0 || y>=data.itemNum){
			return;
		}
		//wʒuőIXg𐮂ĕ\
		showComboItem(x, y);
		//ĕ`
		repaint();
	}
	public void mouseEntered(MouseEvent e) {
	}
	public void mouseExited(MouseEvent e) {
	}
	public void mousePressed(MouseEvent e) {
		//ŃtH[JX𓾂̂ŁAł͕svif[^͗tH[JXDj
		requestFocus();
	}
	public void mouseReleased(MouseEvent e) {
	}
	//I𗓂̏ꏊɕ\
	private void showComboItem(int px,int py){
		//ʒuIΏۂm
		for(int x=1;x<posX.length;x++){
			if(px<posX[x]){
				tmpE=x-1;
				break;
			}
		}
		tmpI=py;
		//Ώelement̑IXg
		if(tmpE==0){	//element 0(ansType)
			if(data.setAnsTypeComboItem(comboItem, tmpI)){	//typetrue߂(typenull̏ꍇ`FbN)
				//͍ς݃f[^ɍ킹
				comboItem.setSelectedIndex(data.getAnsType(tmpI)+1);	//+1
			}else{											//typeȂΉI
				return;
			}
		}else{			//element 1-
			comboItem.removeAllItems();
			comboItem.addItem("-");		//Ip
			for(int i=0;i<data.itemNum;i++){
				comboItem.addItem(data.elems[tmpE].getItem(i/*,MRElement.ITEM_EDIT_ANS*/));
			}
			//͍ς݃f[^ɍ킹
			comboItem.setSelectedIndex(data.getAns(tmpI, tmpE)+1);	//+1
		}
		//\̘gɍ킹
		comboItem.setBounds(baseX+cellSize*posX[tmpE],baseY+cellSize*tmpI,cellSize*(posX[tmpE+1]-posX[tmpE]),cellSize);
		//
		comboItem.setVisible(true);
		//
		comboItem.requestFocus();
	}
	//******************************************************************************************************
	//	R|[lgCxgitB[h̑傫ύX擾j
	//------------------------------------------------------------------------------------------------------
	public void componentResized(ComponentEvent e) {
		setPaintBasePoint();	//pl̃TCYςΕ`挴_Đݒ
	}
	public void componentMoved(ComponentEvent e) {
	}
	public void componentShown(ComponentEvent e) {
	}
	public void componentHidden(ComponentEvent e) {
	}
}
