import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class MRElemEditDialog extends JDialog implements ActionListener {
	//----------萔------------
	//
	//----------ϐ------------
	MRFrame frame;
	MRData data;
	//
	int tmpElemIndex;	//ύXelementꎞۑ
	//element name
	JTextField fieldElemName=new JTextField(8);
	//item
	JTextField[] fieldItems;
	//item edit
	JCheckBox checkItemEdit=new JCheckBox("LE");
	JCheckBox checkItemEditReset=new JCheckBox("͏");	//𓚎҂ɂ̓f[^w
	//category1
	JCheckBox checkCat1=new JCheckBox("LE");
	JTextField[] fieldCat1;
	//category2
	JCheckBox checkCat2=new JCheckBox("LE");
	JTextField[] fieldCat2;
	//order
	JCheckBox checkOrder=new JCheckBox("LE");
	JTextField[] fieldOrder={new JTextField("Ⴂ",3),new JTextField("",3)};
	//
	JButton buttonOk=new JButton("");
	JButton buttonCancel=new JButton("");
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public MRElemEditDialog(MRFrame frm,MRData dat){
		super(frm,"vf̐ݒ",true);
		frame=frm;
		data=dat;	//frm炾NullPointerException
		//
		tmpElemIndex=MRData.NO_DATA;
		//
		//itemς΁A킹čւȂĂ͂Ȃ
		fieldItems=new JTextField[data.itemNum];
		fieldCat1=new JTextField[data.itemNum];
		fieldCat2=new JTextField[data.itemNum];
		for(int i=0;i<data.itemNum;i++) {
			fieldItems[i]=new JTextField(10);
			fieldCat1[i]=new JTextField(4);
			fieldCat2[i]=new JTextField(4);
		}
		//
		checkCat2.setEnabled(false);	//category1Ȃcategory2͑Is
		//2-1
		JPanel panelItem=new JPanel();
		panelItem.setLayout(new GridLayout(data.itemNum+1,1));
		panelItem.add(new JLabel("ږ"));
		for(int i=0;i<data.itemNum;i++) {
			panelItem.add(fieldItems[i]);
		}
		panelItem.setPreferredSize(new Dimension(150,(data.itemNum+1)*25));	//
		//2-2
		JPanel panelItemEdit=new JPanel();
		panelItemEdit.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"OP3ړ"));	//g
		panelItemEdit.setLayout(new GridLayout(data.itemNum+1,1));
		panelItemEdit.add(checkItemEdit);
		for(int i=0;i<data.itemNum-1;i++){		//data.itemNum-1
			panelItemEdit.add(new JLabel("<-----"+(i+1)+"----->"));
		}
		panelItemEdit.add(checkItemEditReset);	//Ō̒iɓ̓f[^w
		//2-3a
		JPanel panelCat1=new JPanel();
		panelCat1.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"OP2aA"));	//g
		panelCat1.setLayout(new GridLayout(data.itemNum+1,1));
		panelCat1.add(checkCat1);
		for(int i=0;i<data.itemNum;i++) {
			panelCat1.add(fieldCat1[i]);
		}
		enableCat1(false);
		//2-3b
		JPanel panelCat2=new JPanel();
		panelCat2.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"OP2bB"));	//g
		panelCat2.setLayout(new GridLayout(data.itemNum+1,1));
		panelCat2.add(checkCat2);
		for(int i=0;i<data.itemNum;i++) {
			panelCat2.add(fieldCat2[i]);
		}
		enableCat2(false);
		//2-4
		JPanel panelOrder=new JPanel();
		panelOrder.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"OP1"));	//g
		panelOrder.setLayout(new GridLayout(data.itemNum+1,1));
		panelOrder.add(checkOrder);
		panelOrder.add(new JLabel(""));
		panelOrder.add(fieldOrder[0]);
		for(int o=0;o<data.itemNum-4;o++){
			panelOrder.add(new JLabel(" "));
		}
		panelOrder.add(fieldOrder[1]);
		panelOrder.add(new JLabel(""));
		enableOrder(false);
		//1
		JPanel panelNor=new JPanel();
		panelNor.add(new JLabel("vf"));
		panelNor.add(fieldElemName);
		//2
		JPanel panelCent=new JPanel();
		panelCent.add(panelItem);
		panelCent.add(panelItemEdit);
		panelCent.add(panelCat1);
		panelCent.add(panelCat2);
		panelCent.add(panelOrder);
		//3
		JPanel panelSou=new JPanel();
		panelSou.add(buttonOk);
		panelSou.add(buttonCancel);
		//Reig
		Container cp=getContentPane();
		cp.add(panelNor,BorderLayout.NORTH);
		cp.add(panelCent,BorderLayout.CENTER);
		cp.add(panelSou,BorderLayout.SOUTH);
		//
		pack();							//TCY
		setLocationRelativeTo(null);	//ʂ̐^񒆂ɕ\(ŏ̂)
		//
		checkItemEdit.addActionListener(this);
		checkCat1.addActionListener(this);
		checkCat2.addActionListener(this);
		checkOrder.addActionListener(this);
		buttonOk.addActionListener(this);
		buttonCancel.addActionListener(this);
	}
	//******************************************************************************************************
	//\Õf[^K
	//------------------------------------------------------------------------------------------------------
	public void setCurrentData(int eIdx){
		//ύXΏۂꎞۑ
		tmpElemIndex=eIdx;
		//
		MRElement elem=data.elems[eIdx];
		//element name
		fieldElemName.setText(elem.elemName);
		//item
		for(int i=0;i<data.itemNum;i++){
			fieldItems[i].setText(elem.itemName[i]);
		}
		//item edit
		if(elem.itemNameEdit==null){
			checkItemEdit.setSelected(false);
			checkItemEditReset.setEnabled(false);
		}else{
			checkItemEdit.setSelected(true);
			checkItemEditReset.setEnabled(true);
		}
		checkItemEditReset.setSelected(false);
		//category1
		if(elem.cat1==null){
			checkCat1.setSelected(false);
			enableCat1(false);
			//
			for(int i=0;i<data.itemNum;i++){
				fieldCat1[i].setText("");
			}
			//category1Ȃcategory2͑Is
			checkCat2.setEnabled(false);
		}else{
			checkCat1.setSelected(true);
			enableCat1(true);
			//
			for(int i=0;i<data.itemNum;i++){
				if(elem.cat1[i]==MRData.NO_DATA){
					fieldCat1[i].setText("");
				}else{
					fieldCat1[i].setText(elem.catLabels1[elem.cat1[i]]);
				}
			}
			//category1LȂcategory2I
			checkCat2.setEnabled(true);
		}
		//category2
		if(elem.cat2==null){
			checkCat2.setSelected(false);
			enableCat2(false);
			//
			for(int i=0;i<data.itemNum;i++){
				fieldCat2[i].setText("");
			}
		}else{
			checkCat2.setSelected(true);
			enableCat2(true);
			//
			for(int i=0;i<data.itemNum;i++){
				if(elem.cat2[i]==MRData.NO_DATA){
					fieldCat2[i].setText("");
				}else{
					fieldCat2[i].setText(elem.catLabels2[elem.cat2[i]]);
				}
			}
		}
		//order
		if(elem.order==null){
			checkOrder.setSelected(false);
			enableOrder(false);
		}else{
			checkOrder.setSelected(true);
			enableOrder(true);
			//
			fieldOrder[0].setText(elem.order[0]);
			fieldOrder[1].setText(elem.order[1]);
		}
	}
	//܂Ƃ߂ėLE
	private void enableCat1(boolean f){
		for(int c=0;c<data.itemNum;c++){
			fieldCat1[c].setEnabled(f);
		}
	}
	private void enableCat2(boolean f){
		for(int c=0;c<data.itemNum;c++){
			fieldCat2[c].setEnabled(f);
		}
	}
	private void enableOrder(boolean f){
		fieldOrder[0].setEnabled(f);
		fieldOrder[1].setEnabled(f);
	}
	//******************************************************************************************************
	//{^Cxg
	//------------------------------------------------------------------------------------------------------
	public void actionPerformed(ActionEvent e) {
		Object object=e.getSource();
		if(object==buttonOk){
			//---------------------------ɓẽ`FbN
			//element name
			if(fieldElemName.getText().equals("")) {
				frame.showErrorMessage("vf͂ł");
				return;
			}
			//item
			for(int i=0;i<data.itemNum;i++){
				if(fieldItems[i].getText().equals("")){
					frame.showErrorMessage("ږ"+(i+1)+"͂ł");
					return;
				}
			}
			//item edit(no work)
			//category1(O`FbN̒iKł͂˂΂Ȃ̂ŁAKp̃f[^܂ōĂ)
			int[] tmpCat1=null;
			ArrayList<String> tmpCatLabels1=null;
			if(checkCat1.isSelected()){
				//
				tmpCat1=new int[data.itemNum];
				tmpCatLabels1=new ArrayList<String>();
				int cont=0;
				//
				String preC="";
				String nowC;
				for(int i=0;i<data.itemNum;i++){
					nowC=fieldCat1[i].getText();
					if(nowC.equals("")){
						if(cont==1){							//wȂŁAO̎w肪PƂ̂ɏIɂȂ
							frame.showErrorMessage("w肪AĂ܂");
							return;
						}else{									//wȂiO͎wȂorAwj
							tmpCat1[i]=MRData.NO_DATA;
							cont=0;
						}
					}else{
						if(nowC.equals(preC)){					//OƓw
							tmpCat1[i]=tmpCat1[i-1];
							cont++;
						}else{
							if(tmpCatLabels1.contains(nowC)){	//OƂ͕ʂAɎgĂw
								frame.showErrorMessage("w肪Ă܂");
								return;
							}else{								//Oƕʂ̐Vw
								tmpCatLabels1.add(nowC);
								tmpCat1[i]=tmpCatLabels1.size()-1;
								cont=1;
							}
						}
					}
					//
					preC=nowC;
				}
				//㏈
				if(cont==1){									//Ō̎w肪PƂŏIɂȂ
					frame.showErrorMessage("w肪AĂ܂");
					return;
				}
				if(tmpCatLabels1.isEmpty()){						//w肪SȂ
					frame.showErrorMessage("w肪܂");
					return;
				}
			}
			//category2(O`FbN̒iKł͂˂΂Ȃ̂ŁAKp̃f[^܂ōĂ)
			int[] tmpCat2=null;
			ArrayList<String> tmpCatLabels2=null;
			if(checkCat2.isSelected()){
				//
				tmpCat2=new int[data.itemNum];
				tmpCatLabels2=new ArrayList<String>();
				int cont=0;
				//
				String preC="";
				String nowC;
				for(int i=0;i<data.itemNum;i++){
					nowC=fieldCat2[i].getText();
					if(nowC.equals("")){
						if(cont==1){							//wȂŁAO̎w肪PƂ̂ɏIɂȂ
							frame.showErrorMessage("w肪AĂ܂");
							return;
						}else{									//wȂiO͎wȂorAwj
							tmpCat2[i]=MRData.NO_DATA;
							cont=0;
						}
					}else{
						if(nowC.equals(preC)){					//OƓw
							tmpCat2[i]=tmpCat2[i-1];
							cont++;
						}else{
							if(tmpCatLabels2.contains(nowC)){	//OƂ͕ʂAɎgĂw
								frame.showErrorMessage("w肪Ă܂");
								return;
							}else{								//Oƕʂ̐Vw
								tmpCatLabels2.add(nowC);
								tmpCat2[i]=tmpCatLabels2.size()-1;
								cont=1;
							}
						}
					}
					//
					preC=nowC;
				}
				//㏈
				if(cont==1){									//Ō̎w肪PƂŏIɂȂ
					frame.showErrorMessage("w肪AĂ܂");
					return;
				}
				if(tmpCatLabels2.isEmpty()){						//w肪SȂ
					frame.showErrorMessage("w肪܂");
					return;
				}
			}
			//order
			if(checkOrder.isSelected()){
				if(fieldOrder[0].getText().equals("")){
					frame.showErrorMessage("n͂ł");
					return;
				}
				if(fieldOrder[1].getText().equals("")){
					frame.showErrorMessage("I͂ł");
					return;
				}
			}
			//---------------------------
			setVisible(false);
			//---------------------------f[^K
			MRElement elem=data.elems[tmpElemIndex];
			//element name
			elem.elemName=fieldElemName.getText();
			//item
			for(int i=0;i<data.itemNum;i++){
				elem.itemName[i]=fieldItems[i].getText();
			}
			//item edit(𓚎҂ɂ̓f[^ǂ邩ŏ)
			if(checkItemEditReset.isEnabled()){
				if(checkItemEditReset.isSelected()){	//? --> editable(𓚎҂ɂ̓f[^)
					elem.formatItemNameEdit(checkItemEdit.isSelected(), data.itemNum);
				}else{
					if(elem.itemNameEdit==null){		//not editable --> editable
						elem.formatItemNameEdit(checkItemEdit.isSelected(), data.itemNum);
					}									//editable --> editable(𓚎҂ɂ̓f[^ύXȂ)
				}
			}else{										//? --> not editable
				elem.formatItemNameEdit(checkItemEdit.isSelected(), data.itemNum);
			}
			//category1(LȂAO`FbNōĂf[^𓖂Ă͂߂)
			if(checkCat1.isSelected()){
				elem.cat1=tmpCat1;
				elem.catLabels1=new String[tmpCatLabels1.size()];
				for(int c=0;c<tmpCatLabels1.size();c++){
					elem.catLabels1[c]=tmpCatLabels1.get(c);
				}
			}else{
				elem.cat1=null;
				elem.catLabels1=null;
			}
			//category2(LȂAO`FbNōĂf[^𓖂Ă͂߂)
			if(checkCat2.isSelected()){
				elem.cat2=tmpCat2;
				elem.catLabels2=new String[tmpCatLabels2.size()];
				for(int c=0;c<tmpCatLabels2.size();c++){
					elem.catLabels2[c]=tmpCatLabels2.get(c);
				}
			}else{
				elem.cat2=null;
				elem.catLabels2=null;
			}
			//order
			if(checkOrder.isSelected()){
				elem.order=new String[]{fieldOrder[0].getText(),fieldOrder[1].getText()};
			}else{
				elem.order=null;
			}
			//itemւ̔ztOݒ
			elem.checkSameItem();
			//---------------------------
			//J[\͂̂܂܂ł
			//Wݒ肵Ȃ
			frame.puzzleField.setCoordinate();
			frame.puzzleField.answerTableDialog.refreshView(tmpElemIndex);	//tmpElemIndexύXO
			//
			frame.fitFrameSize(false,false);
			//f[^ύX
			frame.puzzleField.setChanged(true);
			//---------------------------
			tmpElemIndex=MRData.NO_DATA;
		}else if(object==buttonCancel){
			setVisible(false);
		}else if(object==checkItemEdit){
			checkItemEditReset.setEnabled(checkItemEdit.isSelected());
		}else if(object==checkCat1){
			enableCat1(checkCat1.isSelected());
			//category1̗LEɍ킹category2ݒ
			checkCat2.setEnabled(checkCat1.isSelected());
			if(checkCat1.isSelected()){
				enableCat2(checkCat2.isSelected());
			}else{
				enableCat2(false);
			}
		}else if(object==checkCat2){
			enableCat2(checkCat2.isSelected());
		}else if(object==checkOrder){
			enableOrder(checkOrder.isSelected());
		}
	}
}
