import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Toolkit;
import java.awt.image.BufferedImage;
import java.awt.print.Printable;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;

import javax.imageio.ImageIO;
import javax.print.Doc;
import javax.print.DocFlavor;
import javax.print.DocPrintJob;
import javax.print.PrintException;
import javax.print.PrintService;
import javax.print.PrintServiceLookup;
import javax.print.ServiceUI;
import javax.print.SimpleDoc;
import javax.print.attribute.DocAttributeSet;
import javax.print.attribute.HashDocAttributeSet;
import javax.print.attribute.HashPrintRequestAttributeSet;
import javax.print.attribute.PrintRequestAttributeSet;
import javax.print.event.PrintJobEvent;
import javax.print.event.PrintJobListener;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

public class MRFileIO extends Component implements PrintJobListener {
	//Ăяo
	MRFrame frame;
	//
	JFileChooser chooser;
	//
	File saveFile,graphicFile,preFile;
	//
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public MRFileIO(MRFrame fr){
		//
		frame=fr;
		//vOfBNglɂč쐬
		chooser=new JFileChooser(".");
		//
		saveFile=graphicFile=preFile=null;
	}
	//VK쐬ł̏
	public void formatFileName(){
		saveFile=null;
		//t[̃^CgύX
		frame.setTitleString();
	}
	//-------------------------------------------------------------
	//^Cg
	public String getFileName(){
		if(saveFile!=null){
			return saveFile.getName();
		}else{
			return "";
		}
	}
	//******************************************************************************************************
	//[h
	//------------------------------------------------------------------------------------------------------
	public void load(MRPanel puzzleField){
		//[ht@C̃pX𓾂
		if(!getTargetFile("Z[ut@C(*.csv)J","J",saveFile,false)){	//[hȂȂI
			return;
		}
		//t@Cǂݍ
		File taegetF;
		String[] fileStr;
		//===uRt@Cv̓===
		//1.OX\(Matrix)E𓚕\
		fileStr=readTextFile(preFile);
		if(fileStr==null){
			frame.showErrorMessage("CSVt@C̓ǂݍ݂Ɏs܂B");
			return;
		}
		if(!puzzleField.setLoadString(fileStr)){
			//panelerror
			return;
		}
		//2.qgeLXg
		taegetF=MRSaveDialog.convertFileName(preFile, MRSaveDialog.NAME_HINT_TXT);
		if(taegetF.exists()){
			fileStr=readTextFile(taegetF);
			if(fileStr!=null){
				StringBuilder sb=new StringBuilder();
				for(int t=0;t<fileStr.length;t++){
					sb.append(fileStr[t]).append(System.getProperty("line.separator"));
				}
				puzzleField.hintTextDialog.setHintText(sb.toString());			//
			}else{
				puzzleField.hintTextDialog.setHintText("");			//G[̎͏
			}
		}else{
			puzzleField.hintTextDialog.setHintText("");				//ȂȂAȂł
		}
		//3.qg摜
		taegetF=MRSaveDialog.convertFileName(preFile, MRSaveDialog.NAME_HINT_IMG);
		if(taegetF.exists()){
			puzzleField.hintImageDialog.setImage( inputImage(taegetF) );	//G[̎nullԂi摜j
		}else{
			puzzleField.hintImageDialog.deleteImage();						//ȂȂAȂł
		}
		//Z[ut@Ci[
		saveFile=preFile;
		//iŌɂ܂Ƃ߂āj
		puzzleField.setChanged(false);
		//t[̃^CgύX
		frame.setTitleString();
	}
	//******************************************************************************************************
	//Z[u
	//------------------------------------------------------------------------------------------------------
	//㏑ۑ
	public void save(MRPanel puzzleField,MRSaveDialog saveDialog){
		if(saveFile!=null){
			saveTrifile(saveFile,puzzleField);
		}else{	//Z[ut@C񂪂ȂΖOtĕۑ
			saveAs(puzzleField,saveDialog);
		}
	}
	//Otĕۑ
	public void saveAs(MRPanel puzzleField,MRSaveDialog saveDialog){
		//
		saveDialog.setTrifileInfo(saveFile);
		saveDialog.setVisible(true);
		//saveDialog  getTrifileInfo
	}
	// uRt@Cv̑IisaveDialog j
	public void getTrifileInfo(MRSaveDialog saveDialog){
		//Z[ut@C̃pX𓾂
		if(getTargetFile("Z[ut@C(*.csv)I","I",saveFile,true)){
			//gqtĂȂΕt
			preFile=addExtension(preFile,"csv");
			//
			saveDialog.setTrifileInfo(preFile);
			//saveDialog  saveTrifile
		}
	}
	//uRt@Cv̏óisaveDialog j
	public void saveTrifile(MRPanel puzzleField){
		//
		saveTrifile(preFile,puzzleField);
	}
	//Z[ut@C󂯎 uRt@CṽZ[us
	private void saveTrifile(File file,MRPanel puzzleField){
		//Z[us
		boolean result;
		File targetF;
		//===uRt@Cv̏o===
		//1.OX\(Matrix)E𓚕\(inconstantmark)
		if(!writeTextFile(file,puzzleField.getSaveString(true))){
			frame.showErrorMessage("CSVt@C݂̏Ɏs܂B");
			return;
		}
		//2.qgeLXg
		String ht=puzzleField.hintTextDialog.getHintText();
		targetF=MRSaveDialog.convertFileName(file, MRSaveDialog.NAME_HINT_TXT);
		if(!ht.equals("")){
			result=writeTextFile(targetF,ht);
			if( !result ){
				frame.showErrorMessage("qgeLXg̕ۑɎs܂B");
				return;
			}
		}else{	//̓eLXgȂΎcĂeLXgt@C폜
			deleteRemainingFile(targetF,"cĂqgeLXgt@C̍폜Ɏs܂B");
		}
		//3.qg摜
		Image img=puzzleField.hintImageDialog.getImage();
		targetF=MRSaveDialog.convertFileName(file, MRSaveDialog.NAME_HINT_IMG);
		if(img!=null){
			result=outputImage(img,targetF);
			if( !result ){
				frame.showErrorMessage("qg摜̕ۑɎs܂B");
				return;
			}
		}else{	//摜gȂȂcĂC[W폜
			deleteRemainingFile(targetF,"cĂqg摜t@C̍폜Ɏs܂B");
		}
		//Z[ut@Ci[i㏑ۑł͗]vȏɂȂ邪j
		saveFile=file;
		//iŌɂ܂Ƃ߂āj
		puzzleField.setChanged(false);
		//t[̃^CgύX
		frame.setTitleString();
	}
	private void deleteRemainingFile(File remainingF,String erMsg){
		if(remainingF.exists()){
			try{
				if(!remainingF.delete()){
					frame.showErrorMessage(erMsg);
				}
			}catch(SecurityException se){
				frame.showErrorMessage(erMsg+System.getProperty("line.separator")+se.getMessage());
			}
		}
	}
	//******************************************************************************************************
	//eLXgt@C o
	//------------------------------------------------------------------------------------------------------
	public void outputHintText(MRHintTextDialog htDialog){
		String hT=htDialog.getHintText();
		if(hT.equals("")){
			frame.showErrorMessage("qgeLXg܂B");
		}else{
			if(!writeTextFile(hT,"qgeLXg o",null)){
				frame.showErrorMessage("qgeLXg̏o͂Ɏs܂B");
			}
		}
	}
	//******************************************************************************************************
	//eLXgt@C óiėpj
	//------------------------------------------------------------------------------------------------------
	private boolean writeTextFile(String data,String title,File f){
		//摜t@CI
		if(getTargetFile(title, "o", f,true)){
			//gqtĂȂΕt
			preFile=addExtension(preFile,"txt");
			//
			return writeTextFile(preFile,data);	//G[falseԂ
		}else{
			return true;						//LZ
		}
	}
	//eLXgf[^t@Cɕۑ
	private /*static */boolean writeTextFile(File file,String data){
		try{
			PrintWriter pw=new PrintWriter(new BufferedWriter(new FileWriter(file)));
			pw.print(data);
			pw.close();
			return true;
		}catch(IOException ioe){
			frame.showErrorMessage(file.getName()+" ̏oɃG[܂B"+System.getProperty("line.separator")+ioe.getMessage());
			return false;
		}
	}
	//******************************************************************************************************
	//eLXgt@C 
	//------------------------------------------------------------------------------------------------------
	public boolean inputHintText(MRHintTextDialog htDialog){
		String[] hT=readTextFile("qgeLXg ",null);
		if(hT!=null){
			StringBuilder sb=new StringBuilder();
			for(int t=0;t<hT.length;t++){
				sb.append(hT[t]).append(System.getProperty("line.separator"));
			}
			htDialog.setHintText(sb.toString());
			//
			return true;
		}else{
			return false;	//
		}
	}
	//******************************************************************************************************
	//eLXgt@C ́iėpj
	//------------------------------------------------------------------------------------------------------
	private String[] readTextFile(String title,File f){
		//摜t@CI
		if(getTargetFile(title, "", f,false)){
			return readTextFile(preFile);	//G[nullԂ
		}else{
			return null;					//LZłnullԂ
		}
	}
	//w肳ꂽeLXgt@CǂݍœeԂ
	private /*static */String[] readTextFile(File file){
		try{
			ArrayList<String> stringArray=new ArrayList<String>();
			String line;
			//
			BufferedReader br=new BufferedReader(new FileReader(file));
			while((line=br.readLine())!=null){
				stringArray.add(line);
			}
			br.close();
			//
			String[] ret=new String[stringArray.size()];
			for(int i=0;i<stringArray.size();i++){
				ret[i]=stringArray.get(i);
			}
			return ret;
		}catch(IOException ioe){
			frame.showErrorMessage(file.getName()+" ̓ǂݍݒɃG[܂B"+System.getProperty("line.separator")+ioe.getMessage());
			return null;
		}
	}
	//******************************************************************************************************
	//摜 o
	//------------------------------------------------------------------------------------------------------
	public void outputHintImage(MRHintImageDialog hiDialog) {
		//
		Image img=hiDialog.getImage();
		if(img==null){
			frame.showErrorMessage("qg摜܂B");
			return;
		}
		//
		if( !outputImage(img,"qg摜PNG摜(*.png)ŏo",null) ){
			frame.showErrorMessage("qg摜̏o͂Ɏs܂B");
		}
	}
	//******************************************************************************************************
	//摜 óiėpj
	//------------------------------------------------------------------------------------------------------
	private boolean outputImage(Image img,String title,File f){
		//摜t@CI
		if(getTargetFile(title, "o", f,true)){
			//gqtĂȂΕt
			preFile=addExtension(preFile,"png");
			//
			return outputImage(img,preFile);	//G[falseԂ
		}else{
			return true;						//LZ
		}
	}
	private boolean outputImage(Image img,File f){
		//ۑp摜
		BufferedImage image=new BufferedImage(img.getWidth(this),img.getHeight(this),BufferedImage.TYPE_INT_RGB);
		Graphics g=image.getGraphics();
		//wi𓧉ߐFł锒Ɂi߂̂܂܂ł͕ۑłȂ悤j
		g.setColor(Color.WHITE);
		g.fillRect(0,0,image.getWidth(),image.getHeight());
		//
		g.drawImage(img, 0, 0, this);
		//摜ۑs
		try{
			ImageIO.write(image, "png", f);
		}catch(IOException ioe){
			frame.showErrorMessage(f.getName()+" ̏oɃG[܂B"+System.getProperty("line.separator")+ioe.getMessage());
			return false;	//s
		}
		//
		return true;		//
	}
	//******************************************************************************************************
	//摜 
	//------------------------------------------------------------------------------------------------------
	public boolean inputHintImage(MRHintImageDialog hiDialog) {
		//
		Image img=inputImage("qg摜 ",null);
		if(img!=null){
			hiDialog.setImage(img);
			return true;
		}else{
			return false;
		}
	}
	//******************************************************************************************************
	//摜 ́iėpj
	//------------------------------------------------------------------------------------------------------
	private Image inputImage(String title,File f){
		//摜t@CI
		if(getTargetFile(title, "", f,false)){
			return inputImage(preFile);	//G[nullԂ
		}else{
			return null;				//LZłnullԂ
		}
	}
	private Image inputImage(File f){
		//
		Image retImage=Toolkit.getDefaultToolkit().getImage(f.getPath());
		MediaTracker mt=new MediaTracker(this);
		mt.addImage(retImage,0);
		//fBAgbJ[œǂݍݏI܂ő҂
		try{
			mt.waitForAll();
		}catch(InterruptedException ie){
			frame.showErrorMessage(f.getName()+" ̓ǂݍݒɃG[܂B"+System.getProperty("line.separator")+ie.getMessage());
			return null;
		}
		//
		return retImage;
	}
	//******************************************************************************************************
	//摜ۑipƂĎȂłj
	//------------------------------------------------------------------------------------------------------
	public void outputGraphic(ImageOutputable field){	//OX\(matrix)Ɖ𓚕\̉摜o
		//摜
		Dimension dim=field.getPreferredSize();
		BufferedImage image=new BufferedImage(dim.width,dim.height,BufferedImage.TYPE_INT_RGB);
		Graphics g=image.getGraphics();
		g.setColor(Color.WHITE);	//wi𔒂ɂ˂΂ȂȂij
		g.fillRect(0,0,image.getWidth(),image.getHeight());
		//摜ɏ
		field.paintGraphic(image.getGraphics());
		//o͐̉摜t@C̃pX𓾂
		if(getTargetFile("PNG摜(*.png)ɕۑ","ۑ",graphicFile,true)){
			//gqtĂȂΕt
			preFile=addExtension(preFile,"png");
			//摜ۑs
			try{
				ImageIO.write(image, "png", preFile);
			}catch(IOException ioe){
				frame.showErrorMessage("摜ۑɎs܂B"+System.getProperty("line.separator")+ioe.getMessage());
				return;
			}
			//t@CXV
			graphicFile=preFile;
		}
	}
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public void printField(Printable field){
		//IuWFNgMIME (Multipurpose Internet Mail Extensions) ^Cv̓
		DocFlavor flavor=DocFlavor.SERVICE_FORMATTED.PRINTABLE;
		//f[^Wuɗ^邽߂̃C^[tF[X
		DocAttributeSet das=new HashDocAttributeSet();
		Doc doc=new SimpleDoc(field,flavor,das);
		//ǂ̂悤Ɉ邩
		PrintRequestAttributeSet pras=new HashPrintRequestAttributeSet();
		//ftHg̈T[rXiv^[EIuWFNgj擾
		PrintService defaultService=PrintServiceLookup.lookupDefaultPrintService();
		//****************************_CAO\********************************************
		//̕^Cv (GIFȂ) ̑Zbg (ʂȂ) ł̈T|[gv^[̃Zbg
		PrintService[] printServices=PrintServiceLookup.lookupPrintServices(flavor,pras);
		//v^[I_CAO\
		PrintService service=ServiceUI.printDialog(null,200,200,printServices,defaultService,flavor,pras);
		//Wu쐬
		DocPrintJob job;
		if(service!=null){
			job=service.createPrintJob();
		}else{
			return;
		}
		//*************************************************************************************
		//֘ÃCxg󂯎悤ɂ
		job.addPrintJobListener(this);
		//
		try{
			job.print(doc,pras);
		}catch(PrintException pe){
			frame.showErrorMessage("Ɏs܂B"+System.getProperty("line.separator")+pe.getMessage());
			return;
		}
	}
	//******************************************************************************************************
	//t@C 擾iėpj
	//------------------------------------------------------------------------------------------------------
	//ΏۂƂȂt@C擾i擾trueԂj
	private boolean getTargetFile(String title,String button,File file,boolean overwrite){
		chooser.setSelectedFile(file);
		//
		chooser.setDialogTitle(title);
		//ꎞt@CɎ擾
		File tmpFile;
		while (true) {
			if (chooser.showDialog(frame,button) != JFileChooser.APPROVE_OPTION) {
				return false;
			}
			tmpFile = chooser.getSelectedFile();
			//㏑mFKvȂ炷
			if(!overwrite){	break;	}
			if (tmpFile.exists()) {
				switch (JOptionPane.showConfirmDialog(frame,tmpFile.getName()+" ͊ɑ݂܂B"+System.getProperty("line.separator")+"㏑܂H","mF",JOptionPane.YES_NO_CANCEL_OPTION)){
					case JOptionPane.YES_OPTION:
						break;
					case JOptionPane.NO_OPTION:
						continue;
					case JOptionPane.CANCEL_OPTION:
						return false;
				}
				break;
			} else {
				break;
			}
		}
		//Ă͂
		preFile=tmpFile;
		return true;
	}
	//t@CɎw肳ꂽgqtĂȂΕtiÓISLAppletDialogĂ΂j
	public static File addExtension(File file,String... extension){
		//gqmF
		int period=file.getPath().lastIndexOf(".");
		if(period!=-1){
			for(int e=0;e<extension.length;e++){
				if(file.getPath().substring(period).equals("."+extension[e])){
					return file;	//̊gqtĂ
				}
			}
			//w肳ꂽgqǂtĂȂ
			return new File(file.getPath()+"."+extension[0]);
		}else{	//ŏ牽̊gqtĂȂ
			return new File(file.getPath()+"."+extension[0]);
		}
	}
	//******************************************************************************************************
	//Playero͊֘A
	//------------------------------------------------------------------------------------------------------
	public String[] readSolutionDataForPlayer(String solName){
		File mrkFile=new File(System.getProperty("user.dir")+System.getProperty("file.separator")+solName);
		if(mrkFile.exists()){
			return readTextFile(mrkFile);
		}else{
			return null;
		}
	}
	public void writeSolutionDataForPlayer(String solStr,String solName){
		boolean result=writeTextFile(new File(System.getProperty("user.dir")+System.getProperty("file.separator")+solName),solStr);
		if( !result ){
			frame.showErrorMessage("𓚃f[^̕ۑɎs܂");
		}
	}
	//******************************************************************************************************
	//CxgiɉȂj
	//------------------------------------------------------------------------------------------------------
	public void printDataTransferCompleted(PrintJobEvent pje) {
	}
	public void printJobCompleted(PrintJobEvent pje) {
	}
	public void printJobFailed(PrintJobEvent pje) {
	}
	public void printJobCanceled(PrintJobEvent pje) {
	}
	public void printJobNoMoreEvents(PrintJobEvent pje) {
	}
	public void printJobRequiresAttention(PrintJobEvent pje) {
	}

}
