import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Event;
import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.ButtonGroup;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.JScrollPane;
import javax.swing.KeyStroke;

public class MRFrame extends JFrame implements ActionListener, WindowListener {
	//******************************************************************************************************
	//Nieditpj
	//------------------------------------------------------------------------------------------------------
	public static void main(String[] args) {
		MRFrame frame=new MRFrame(true);	//true
		frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);	//E~ł͉Ȃiŏj
		frame.setVisible(true);
		frame.setLocationRelativeTo(null);	//ʂ̐^񒆂ɕ\
	}
	//----------萔------------
	//^Cgɕt镶
	private static final String TITLE_STRING=" - MatrixReasoningPlayer";
	//----------ϐ------------
	//ʏ̕ҏWpitruejo͂Playerpiflasej̃tO
	boolean editF;
	//
	MRPanel puzzleField;		//pY{
	MRFileIO fileIO;			//o
	MRNewDialog newDialog;		//VKpY쐬_CAO
	MRSaveDialog saveDialog;	//
	MRSizeDialog sizeDialog;	//TCYύX_CAO
	MROutPlayerDialog outPlayerDialog;	//Playero̓_CAO
	MRInfoDialog infoDialog;
	//
	JMenuBar mainMenu=new JMenuBar();
	//
	JMenu menuFile=new JMenu("t@C(F)");
	JMenuItem menuItemNew=new JMenuItem("VK(N)...");
	JMenuItem menuItemChange=new JMenuItem("ύX(C)...");
	JMenuItem menuItemOpen=new JMenuItem("J(O)");
	JMenuItem menuItemSave=new JMenuItem("㏑ۑ(S)");
	JMenuItem menuItemSaveAs=new JMenuItem("Otĕۑ(R)...");
	JMenuItem menuItemGraphicOut=new JMenuItem("摜ۑ(OX\)(G)...");
	JMenuItem menuItemPrint=new JMenuItem("(OX\)(P)...");
	JMenuItem menuItemGraphicOutAns=new JMenuItem("摜ۑ(𓚕\)(T)...");
	JMenuItem menuItemPrintAns=new JMenuItem("(𓚕\)(A)...");
	JMenuItem menuItemExit=new JMenuItem("I(X)");
	//
	JMenu menuEdit=new JMenu("ҏW(E)");
	JRadioButtonMenuItem menuItemAnswer=new JRadioButtonMenuItem("𓚃[h(A)");
	JRadioButtonMenuItem menuItemEdit=new JRadioButtonMenuItem("̓[h(E)");
	JCheckBoxMenuItem menuItemAutoXAdd=new JCheckBoxMenuItem("O͂X(I)");
	JCheckBoxMenuItem menuItemAutoXDel=new JCheckBoxMenuItem("O폜X폜(D)");
	JMenuItem menuItemFillX=new JMenuItem("OsXŖ߂(X)");
	JMenuItem menuItemFillO=new JMenuItem("PƋ}XOŖ߂(O)");
	JMenuItem menuItemClearMark=new JMenuItem("OX\ 𓚏(C)");
	JMenuItem menuItemMatrixToAnswer=new JMenuItem("f(OX\->𓚕\)(M)");
	JMenuItem menuItemClearAnsTable=new JMenuItem("𓚕\ (F)");
	JMenuItem menuItemAnswerToMatrix=new JMenuItem("f(𓚕\->OX\)(R)");
	JMenuItem menuItemProceedAnswer=new JMenuItem("𓚂i߂ (P)");
	JMenuItem menuItemRemoveContradiction=new JMenuItem("Zbg(Q)");
	JMenuItem menuItemCheckAnswer=new JMenuItem(" (J)");
	//
	JMenu menuView=new JMenu("\(V)");
	JMenuItem menuItemSize=new JMenuItem("\TCY(S)...");
	JMenuItem menuItemSizeFit=new JMenuItem("t[TCY(F)");
	JCheckBoxMenuItem menuItemCursor=new JCheckBoxMenuItem("J[\\(C)");
	JCheckBoxMenuItem menuItemErrorView=new JCheckBoxMenuItem("G[E\(E)");
	JCheckBoxMenuItem menuItemAnswerView=new JCheckBoxMenuItem("𓚂\(A)");
	JCheckBoxMenuItem menuItemDialogHintText=new JCheckBoxMenuItem("qgeLXg(H)");
	JCheckBoxMenuItem menuItemDialogHintImage=new JCheckBoxMenuItem("qg摜(I)");
	JCheckBoxMenuItem menuItemDialogAnswerTable=new JCheckBoxMenuItem("𓚕\(J)");
	//
	JMenu menuIO=new JMenu("o(P)");
	JMenuItem menuItemOutExe=new JMenuItem("st@C o(E)...");
	JMenuItem menuItemInHintText=new JMenuItem("qgeLXg (T)...");
	JMenuItem menuItemOutHintText=new JMenuItem("qgeLXg o(U)...");
	JMenuItem menuItemInHintImage=new JMenuItem("qg摜 (I)...");
	JMenuItem menuItemOutHintImage=new JMenuItem("qg摜 o(J)...");
	JMenuItem menuItemDeleteHintImage=new JMenuItem("qg摜 폜(D)");
	//
	JMenu menuHelp=new JMenu("wv(H)");
	JMenuItem menuItemInfo=new JMenuItem("(I)");
	JMenuItem menuItemAbout=new JMenuItem("MatrixReasoningPlayerɂ(A)");
	//******************************************************************************************************
	//it[̃^CgύXfileIOsj
	//------------------------------------------------------------------------------------------------------
	public MRFrame(boolean edit){
		editF=edit;
		//
		//=====PlayerΉ1/2=====
		outPlayerDialog=new MROutPlayerDialog(this);
		infoDialog=new MRInfoDialog(this);
		//	0.t@C(menuoptionw肪̂Őɓǂݍ)
		if(!editF){
			if(!outPlayerDialog.getInfoFromPlayer(infoDialog)){
				showErrorMessage("I܂");	//t@CȂΈȌ̑͂łȂ
				System.exit(0);
			}
		}
		//======================
		//
		//TCYݒ
		//iŏɏ\傫ݒ肵Ă˂΁AŃTCYsĂLĂȂBȂ낤Hj
		setSize(600,600);
		//Reig
		Container cp=getContentPane();
		//
		puzzleField=new MRPanel(this);
		JScrollPane scPanel=new JScrollPane(puzzleField);
		cp.add(scPanel,BorderLayout.CENTER);
		//
		//WI{^ݒ
		ButtonGroup bg=new ButtonGroup();
		bg.add(menuItemAnswer);
		bg.add(menuItemEdit);
		menuItemAnswer.setSelected(true);
		puzzleField.changePuzzleMode(MRPanel.MODE_ANSWER);
		//`FbN{bNXݒ
		menuItemCursor.setSelected(true);
		//puzzleField.setCursorViewFlag(menuItemCursor.getState());
		menuItemErrorView.setSelected(true);
		menuItemAutoXAdd.setSelected(true);
		menuItemAutoXDel.setSelected(true);
		menuItemDialogHintText.setSelected(true);
		menuItemDialogHintImage.setSelected(true);
		if(editF){			//Editorł͕\APlayerł͔\ianswer tableɓnāAɎgj
			menuItemDialogAnswerTable.setSelected(true);
		}
		//
		fileIO=new MRFileIO(this);
		setTitleString();	//^Cgݒ͏o̓NX쐬
		//
		newDialog=new MRNewDialog(this);
		saveDialog=new MRSaveDialog(this,fileIO);
		sizeDialog=new MRSizeDialog(this);
		//
		if(editF){
			menuFile.add(menuItemNew);
			menuFile.add(menuItemChange);
			menuFile.add(menuItemOpen);
			menuFile.addSeparator();
			menuFile.add(menuItemSave);
			menuFile.add(menuItemSaveAs);
			menuFile.addSeparator();
		}
		menuFile.add(menuItemGraphicOut);
		menuFile.add(menuItemPrint);
		if(editF){
			menuFile.addSeparator();
			menuFile.add(menuItemGraphicOutAns);
			menuFile.add(menuItemPrintAns);
		}
		menuFile.addSeparator();
		menuFile.add(menuItemExit);
		//
		if(editF){
			menuEdit.add(menuItemAnswer);
			menuEdit.add(menuItemEdit);
			menuEdit.addSeparator();
		}
		menuEdit.add(menuItemAutoXAdd);
		menuEdit.add(menuItemAutoXDel);
		menuEdit.add(menuItemFillX);
		menuEdit.add(menuItemFillO);
		menuEdit.addSeparator();
		menuEdit.add(menuItemClearMark);
		if(editF){
			menuEdit.add(menuItemMatrixToAnswer);
			menuEdit.addSeparator();
			menuEdit.add(menuItemClearAnsTable);
			menuEdit.add(menuItemAnswerToMatrix);
			menuEdit.addSeparator();
			menuEdit.add(menuItemProceedAnswer);
			menuEdit.add(menuItemRemoveContradiction);
			menuEdit.add(menuItemCheckAnswer);
		}else{		//=====PlayerIvVw=====
			if(outPlayerDialog.infoOptProceed || outPlayerDialog.infoOptCheck){
				menuEdit.addSeparator();
			}
			if(outPlayerDialog.infoOptProceed){
				menuEdit.add(menuItemProceedAnswer);
				menuEdit.add(menuItemRemoveContradiction);
			}
			if(outPlayerDialog.infoOptCheck){
				menuEdit.add(menuItemCheckAnswer);
			}
		}
		//
		menuView.add(menuItemSize);
		menuView.add(menuItemSizeFit);
		menuView.addSeparator();
		menuView.add(menuItemCursor);
		menuView.add(menuItemErrorView);
		if(editF){
			menuView.add(menuItemAnswerView);
		}
		menuView.addSeparator();
		menuView.add(menuItemDialogHintText);
		menuView.add(menuItemDialogHintImage);
		if(editF){
			menuView.add(menuItemDialogAnswerTable);
		}
		//
		menuIO.add(menuItemOutExe);
		menuIO.addSeparator();
		menuIO.add(menuItemInHintText);
		menuIO.add(menuItemOutHintText);
		menuIO.addSeparator();
		menuIO.add(menuItemInHintImage);
		menuIO.add(menuItemOutHintImage);
		menuIO.add(menuItemDeleteHintImage);
		//
		if(!editF){	//PlayerȂAҏ
			menuHelp.add(menuItemInfo);
		}
		menuHelp.add(menuItemAbout);
		//
		mainMenu.add(menuFile);
		mainMenu.add(menuEdit);
		mainMenu.add(menuView);
		if(editF){	mainMenu.add(menuIO);		}
		mainMenu.add(menuHelp);
		setJMenuBar(mainMenu);
		//j[jbNiL[{[hAlt+?őIj
		menuFile.setMnemonic(KeyEvent.VK_F);
		menuItemNew.setMnemonic(KeyEvent.VK_N);
		menuItemChange.setMnemonic(KeyEvent.VK_C);
		menuItemOpen.setMnemonic(KeyEvent.VK_O);
		menuItemSave.setMnemonic(KeyEvent.VK_S);
		menuItemSaveAs.setMnemonic(KeyEvent.VK_R);
		menuItemGraphicOut.setMnemonic(KeyEvent.VK_G);
		menuItemPrint.setMnemonic(KeyEvent.VK_P);
		menuItemGraphicOutAns.setMnemonic(KeyEvent.VK_T);
		menuItemPrintAns.setMnemonic(KeyEvent.VK_A);
		menuItemExit.setMnemonic(KeyEvent.VK_X);
		menuEdit.setMnemonic(KeyEvent.VK_E);
		menuItemAnswer.setMnemonic(KeyEvent.VK_A);
		menuItemEdit.setMnemonic(KeyEvent.VK_E);
		menuItemAutoXAdd.setMnemonic(KeyEvent.VK_I);
		menuItemAutoXDel.setMnemonic(KeyEvent.VK_D);
		menuItemFillX.setMnemonic(KeyEvent.VK_X);
		menuItemFillO.setMnemonic(KeyEvent.VK_O);
		menuItemClearMark.setMnemonic(KeyEvent.VK_C);
		menuItemMatrixToAnswer.setMnemonic(KeyEvent.VK_M);
		menuItemClearAnsTable.setMnemonic(KeyEvent.VK_F);
		menuItemAnswerToMatrix.setMnemonic(KeyEvent.VK_R);
		menuItemProceedAnswer.setMnemonic(KeyEvent.VK_P);
		menuItemRemoveContradiction.setMnemonic(KeyEvent.VK_Q);
		menuItemCheckAnswer.setMnemonic(KeyEvent.VK_J);
		menuView.setMnemonic(KeyEvent.VK_V);
		menuItemSize.setMnemonic(KeyEvent.VK_S);
		menuItemSizeFit.setMnemonic(KeyEvent.VK_F);
		menuItemCursor.setMnemonic(KeyEvent.VK_C);
		menuItemErrorView.setMnemonic(KeyEvent.VK_E);
		menuItemAnswerView.setMnemonic(KeyEvent.VK_A);
		menuItemDialogHintText.setMnemonic(KeyEvent.VK_H);
		menuItemDialogHintImage.setMnemonic(KeyEvent.VK_I);
		menuItemDialogAnswerTable.setMnemonic(KeyEvent.VK_J);
		menuIO.setMnemonic(KeyEvent.VK_P);
		menuItemOutExe.setMnemonic(KeyEvent.VK_E);
		menuItemInHintText.setMnemonic(KeyEvent.VK_T);
		menuItemOutHintText.setMnemonic(KeyEvent.VK_U);
		menuItemInHintImage.setMnemonic(KeyEvent.VK_I);
		menuItemOutHintImage.setMnemonic(KeyEvent.VK_J);
		menuItemDeleteHintImage.setMnemonic(KeyEvent.VK_D);
		menuHelp.setMnemonic(KeyEvent.VK_H);
		menuItemInfo.setMnemonic(KeyEvent.VK_I);
		menuItemAbout.setMnemonic(KeyEvent.VK_A);
		//ANZ[^[iL[{[h̃V[gJbgj
		menuItemNew.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N,Event.CTRL_MASK));
		menuItemOpen.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O,Event.CTRL_MASK));
		menuItemSave.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,Event.CTRL_MASK));
		menuItemSaveAs.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_R,Event.CTRL_MASK));
		menuItemExit.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X,Event.CTRL_MASK));
		menuItemAnswer.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F2,0));
		menuItemEdit.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F3,0));
		menuItemDialogHintText.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F5,0));
		menuItemDialogHintImage.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F6,0));
		menuItemDialogAnswerTable.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F7,0));
		//ẽCxg
		menuItemNew.addActionListener(this);
		menuItemChange.addActionListener(this);
		menuItemOpen.addActionListener(this);
		menuItemSave.addActionListener(this);
		menuItemSaveAs.addActionListener(this);
		menuItemGraphicOut.addActionListener(this);
		menuItemPrint.addActionListener(this);
		menuItemGraphicOutAns.addActionListener(this);
		menuItemPrintAns.addActionListener(this);
		menuItemExit.addActionListener(this);
		menuItemAnswer.addActionListener(this);
		menuItemEdit.addActionListener(this);
		menuItemAutoXAdd.addActionListener(this);
		menuItemAutoXDel.addActionListener(this);
		menuItemFillX.addActionListener(this);
		menuItemFillO.addActionListener(this);
		menuItemClearMark.addActionListener(this);
		menuItemMatrixToAnswer.addActionListener(this);
		menuItemClearAnsTable.addActionListener(this);
		menuItemAnswerToMatrix.addActionListener(this);
		menuItemProceedAnswer.addActionListener(this);
		menuItemRemoveContradiction.addActionListener(this);
		menuItemCheckAnswer.addActionListener(this);
		menuItemSize.addActionListener(this);
		menuItemSizeFit.addActionListener(this);
		menuItemCursor.addActionListener(this);
		menuItemErrorView.addActionListener(this);
		menuItemAnswerView.addActionListener(this);
		menuItemDialogHintText.addActionListener(this);
		menuItemDialogHintImage.addActionListener(this);
		menuItemDialogAnswerTable.addActionListener(this);
		menuItemOutExe.addActionListener(this);
		menuItemInHintText.addActionListener(this);
		menuItemOutHintText.addActionListener(this);
		menuItemInHintImage.addActionListener(this);
		menuItemOutHintImage.addActionListener(this);
		menuItemDeleteHintImage.addActionListener(this);
		menuItemInfo.addActionListener(this);
		menuItemAbout.addActionListener(this);
		addWindowListener(this);
		//t[TCY߂Ɏg߃XN[̈niƕ𓾂Ȃ̂ōŌɓnj
		puzzleField.setScrollEdge(scPanel);
		//
		//=====PlayerΉ2/2=====
		if( !editF ){
			//	0.t@C͍ŏɓǂݍݍς
			//===uRt@Cv̓===
			//	1.OX\(Matrix)E𓚕\(jarsave file܂Ƃ߂ēǂݍ݁Ainconstantmark͋̂͂)
			puzzleField.setLoadString(outPlayerDialog.getMatrixDataFromPlayer());
			//	1'.OIɎۑ𓚃t@Cit@C擾AсATCYύXŁj
			String[] solStr=fileIO.readSolutionDataForPlayer(outPlayerDialog.getSolutionName());
			if(solStr!=null){
				String erMsg=puzzleField.puzzleData.setSolutionString(solStr);
				if(erMsg!=null){	//f[^KsiG[j
					showErrorMessage("ۑ𓚃f[^܂B"+System.getProperty("line.separator")+erMsg);
					//G[łAǂݍ߂f[^݂̂ő
				}
			}						//t@CȂꍇiG[ł͂Ȃj
			//	2.qgeLXg(outPlayerDialogŃG[)
			puzzleField.hintTextDialog.setHintText(outPlayerDialog.getHintTextFromPlayer());
			//	3.qg摜(outPlayerDialogŃG[)
			Image hImg=outPlayerDialog.getHintImageFromPlayer();
			if(hImg==null){
				menuView.remove(menuItemDialogHintImage);	//摜Ȃ΃j[ڂ\Ȃ
				puzzleField.hintImageDialog.setImage(null);	//isvj
			}else{
				puzzleField.hintImageDialog.setImage(hImg);
			}
		}
		//^CgH
		//======================
	}
	//******************************************************************************************************
	//j[Cxg
	//------------------------------------------------------------------------------------------------------
	public void actionPerformed(ActionEvent e) {
		Object object=e.getSource();
		if(object==menuItemNew){
			if(checkChangedData()){		//pYpOɃpYf[^ύXȂ`FbN
				newDialog.setRole(MRNewDialog.ROLE_NEW);
				newDialog.setVisible(true);
			}
		}else if(object==menuItemChange){
			//݂̃f[^𔽉fĕ\ipYf[^ύX̃`FbN͕svj
			newDialog.setCurrentData(puzzleField.puzzleData);
			newDialog.setRole(MRNewDialog.ROLE_CHANGE);
			newDialog.setVisible(true);
		}else if(object==menuItemOpen){
			if(checkChangedData()){		//pYpOɃpYf[^ύXȂ`FbN
				fileIO.load(puzzleField);
				fitFrameSize(false,false);
			}
		}else if(object==menuItemSave){
			fileIO.save(puzzleField,saveDialog);
		}else if(object==menuItemSaveAs){
			fileIO.saveAs(puzzleField,saveDialog);
		}else if(object==menuItemGraphicOut){
			fileIO.outputGraphic(puzzleField);
		}else if(object==menuItemPrint){
			fileIO.printField(puzzleField);
		}else if(object==menuItemGraphicOutAns){
			fileIO.outputGraphic(puzzleField.getAnsTablePanel());
		}else if(object==menuItemPrintAns){
			fileIO.printField(puzzleField.getAnsTablePanel());
		}else if(object==menuItemExit){
			checkExit();	//IȌieditplayňقȂj
		}else if(object==menuItemAnswer){
			puzzleField.changePuzzleMode(MRPanel.MODE_ANSWER);
		}else if(object==menuItemEdit){
			puzzleField.changePuzzleMode(MRPanel.MODE_EDIT);
		}else if(object==menuItemAutoXAdd){
			puzzleField.setAutoXAddFlag(menuItemAutoXAdd.getState());
		}else if(object==menuItemAutoXDel){
			puzzleField.setAutoXDelFlag(menuItemAutoXDel.getState());
		}else if(object==menuItemFillX){
			puzzleField.fillCross();
		}else if(object==menuItemFillO){
			puzzleField.fillCircle();
		}else if(object==menuItemClearMark){
			puzzleField.deleteMatrixAnswer();
		}else if(object==menuItemMatrixToAnswer){
			puzzleField.reflectMatrixToAnswer();
		}else if(object==menuItemClearAnsTable){
			puzzleField.formatAnswerTable();
		}else if(object==menuItemAnswerToMatrix){
			puzzleField.reflectAnswerToMatrix();
		}else if(object==menuItemProceedAnswer){
			puzzleField.proceedAnswer();
		}else if(object==menuItemRemoveContradiction){
			puzzleField.removeContradiction();
		}else if(object==menuItemCheckAnswer){
			puzzleField.checkAnswer();
		}else if(object==menuItemSize){
			sizeDialog.setValue(puzzleField.getCellSize());
			sizeDialog.setVisible(true);
		}else if(object==menuItemSizeFit){
			fitFrameSize(true,false);		//t[pYɃsb^킹
		}else if(object==menuItemCursor){
			puzzleField.setCursorViewFlag(menuItemCursor.getState());
		}else if(object==menuItemErrorView){
			puzzleField.setErrorViewFlag(menuItemErrorView.getState());
		}else if(object==menuItemAnswerView){
			puzzleField.setAnswerViewFlag(menuItemAnswerView.getState());
		}else if(object==menuItemDialogHintText){
			puzzleField.showHintTextDialog(menuItemDialogHintText.getState());
		}else if(object==menuItemDialogHintImage){
			puzzleField.showHintImageDialog(menuItemDialogHintImage.getState());
		}else if(object==menuItemDialogAnswerTable){
			puzzleField.showAnswerTableDialog(menuItemDialogAnswerTable.getState());
		}else if(object==menuItemOutExe){
			outPlayerDialog.setVisible(true);
		}else if(object==menuItemInHintText){
			puzzleField.inputHintText(fileIO);
		}else if(object==menuItemOutHintText){
			puzzleField.outputHintText(fileIO);
		}else if(object==menuItemInHintImage){
			puzzleField.inputHintImage(fileIO);
		}else if(object==menuItemOutHintImage){
			puzzleField.outputHintImage(fileIO);
		}else if(object==menuItemDeleteHintImage){
			puzzleField.deleteHintImage();
		}else if(object==menuItemInfo){
			infoDialog.setVisible(true);
		}else if(object==menuItemAbout){
			JOptionPane.showMessageDialog(this,
					"MatrixReasoningPlayer version 1.0\n\nPuzzle Workshop TAKANA\nhttp://www.takana.info/",
					"MatrixReasoningPlayerɂ",JOptionPane.INFORMATION_MESSAGE);
		}
	}
	//******************************************************************************************************
	// VKEύXinewDialog j
	//------------------------------------------------------------------------------------------------------
	//VKpY쐬
	public void newPuzzle(int eNum,int iNum,String typeE,String[] typeWs){
		puzzleField.formatPuzzle(eNum, iNum, typeE, typeWs);
		fileIO.formatFileName();
		//
		fitFrameSize(false,false);
	}
	//TCYύX
	public void changePuzzle(int eNum,int iNum,String typeE,String[] typeWs){
		puzzleField.changePuzzle(eNum, iNum, typeE, typeWs);
		//
		fitFrameSize(false,false);
	}
	//-------------------------------------------------------------
	//t[TCYpYɍ킹Ē
	//iĂ΂邪A}X̃TCYύXSizeDialogڌĂ΂j
	//ij[ut[TCY߁v̂݃sb^tOtruej
	public void fitFrameSize(boolean shortenFlag,boolean viewF){
		//[matrix]
		Dimension differ=puzzleField.getSizeDifference();	//TCYߏ蕪擾
		if(!shortenFlag){	//sb^ɒȂȂ傫̂͂̂܂
			if(differ.width>0){		differ.width=0;		}
			if(differ.height>0){	differ.height=0;	}
		}
		setSize(getWidth()-differ.width,getHeight()-differ.height);
		setVisible(true);	//1sƃt[̃tB[hȂǂTCYȂiȂHj
		//
		puzzleField.setDialogPos(viewF);	//Tut[̈ʒu𒲐AN͕\
		//
		//[answer table]
		//ieɍ킹t[TCY̒́A\łȂƂȂ悤j
		puzzleField.answerTableDialog.fitFrameSize(shortenFlag);
		//[hint text]
		//Ct[ɍ킹
		puzzleField.hintTextDialog.setSize(puzzleField.hintTextDialog.getWidth(),getHeight());
	}
	//-------------------------------------------------------------
	//}X̃TCYύX
	public void changeSquareSize(int v){
		//ꎞIɃ}Xƃpl̃TCŶݕύX
		//iŁA[matrix],[answer table],[hint text]܂Ƃ߂ĕύXj
		puzzleField.setCellSize(v);
		puzzleField.adjustPanelSize();
		//ł̓t[TCY͕ύXȂiŏIISizeDialog璼ڂj
	}
	//******************************************************************************************************
	//^Cg
	//------------------------------------------------------------------------------------------------------
	public void setTitleString(){
		if(editF){	//Editor
			if(puzzleField.checkChanged()){	//f[^ύXiɈĎj
				setTitle("*"+fileIO.getFileName()+TITLE_STRING);
			}else{							//f[^ύXȂ
				setTitle(fileIO.getFileName()+TITLE_STRING);
			}
		}else{		//Playerł͎w肳ꂽ^Cg
			setTitle(outPlayerDialog.infoTitle+TITLE_STRING);
		}
	}
	//******************************************************************************************************
	//bZ[W\
	//------------------------------------------------------------------------------------------------------
	public void showInfoMessage(String message,String title){
		JOptionPane.showMessageDialog(this,	message,title,JOptionPane.INFORMATION_MESSAGE);
	}
	public void showErrorMessage(String message){
		JOptionPane.showMessageDialog(this,message,"G[",JOptionPane.ERROR_MESSAGE);
	}
	//******************************************************************************************************
	//EBhECxg
	//------------------------------------------------------------------------------------------------------
	public void windowOpened(WindowEvent e) {
	}
	public void windowClosing(WindowEvent e) {
		checkExit();	//IȌieditplayňقȂj
	}
	public void windowClosed(WindowEvent e) {
	}
	public void windowIconified(WindowEvent e) {
	}
	public void windowDeiconified(WindowEvent e) {
	}
	public void windowActivated(WindowEvent e) {
	}
	public void windowDeactivated(WindowEvent e) {
	}
	//IȌ
	private void checkExit(){
		if(editF){	//Editor
			if(checkChangedData()){		//OɃpYf[^ύXȂ`FbN
				System.exit(0);
			}
		}else{		//Player
			//OɁA͂Ă𓚂JAR̊OɎŕۑ(inconstantmark)
			fileIO.writeSolutionDataForPlayer(puzzleField.puzzleData.getSolutionString(), outPlayerDialog.getSolutionName());
			System.exit(0);
		}
	}
	//pYf[^ύXΒӂ𑣂AZ[uipȂtrueԂj
	private boolean checkChangedData(){
		if(puzzleField.checkChanged()){
			int ret=JOptionPane.showConfirmDialog(this,"eύXĂ܂B"+System.getProperty("line.separator")+"ۑ܂H",
					"mF",JOptionPane.YES_NO_CANCEL_OPTION,JOptionPane.WARNING_MESSAGE);
			if(ret==JOptionPane.YES_OPTION){
				fileIO.save(puzzleField,saveDialog);
			}else if(ret==JOptionPane.CANCEL_OPTION){
				return false;
			}
		}
		return true;
	}
}
