import java.awt.Font;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.JPanel;

public class MRHintImagePanel extends JPanel implements MouseListener{
	//----------萔------------
	//
	//----------ϐ------------
	MRFrame frame;
	//
	Image hintImage;
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public MRHintImagePanel(Image hImage,MRFrame frm){
		frame=frm;
		hintImage=hImage;			//
		//
		addMouseListener(this);
	}
	//******************************************************************************************************
	//C[W
	//------------------------------------------------------------------------------------------------------
	public Image getImage(){
		return hintImage;
	}
	public void setImage(Image hImage){
		hintImage=hImage;
		//
		repaint();
	}
	public void deleteImage(){
		hintImage=null;
		//
		repaint();
	}
	//******************************************************************************************************
	//pl̃TCYɍ킹ĉ摜\
	//------------------------------------------------------------------------------------------------------
	public void paintComponent(Graphics g){
		super.paintComponents(g);
		//
		if(hintImage==null){
			int fS=MRPanel.DEF_CELL-MRPanel.DEF_FONT_DIFF*2;
			g.setFont(new Font( null, Font.PLAIN, fS));
			if(frame.puzzleField.puzzleMode==MRPanel.MODE_EDIT){
				g.drawString("NbN", fS, fS*2);
				g.drawString("-->摜ǂݍ", fS, fS*3);
				g.drawString("ENbN", fS, fS*5);
				g.drawString("i܂̓VtgL[j", fS, fS*6);
				g.drawString("-->摜", fS, fS*7);
				return;
			}else{
				g.drawString("ډ摜̑ɂ", fS, fS*2);
				g.drawString("̓[hɂĂ", fS, fS*3);
				g.drawString("j[Ȃ", fS, fS*5);
				g.drawString("𓚃[hłł܂", fS, fS*6);
				return;
			}
		}
		//
		//doubleŔrƓ삪̂
		int wTimes=(int)(getWidth()*100/hintImage.getWidth(this));
		int hTimes=(int)(getHeight()*100/hintImage.getHeight(this));
		if( wTimes < hTimes ){	//摜̏c͕ςȂ
			int hSize=(int)(hintImage.getHeight(this)*getWidth()/hintImage.getWidth(this));
			g.drawImage(hintImage,0,(int)((getHeight()-hSize)/2),getWidth(),hSize,this);
		}else{
			int wSize=(int)(hintImage.getWidth(this)*getHeight()/hintImage.getHeight(this));
			g.drawImage(hintImage,(int)((getWidth()-wSize)/2),0,wSize,getHeight(),this);
		}
	}
	//******************************************************************************************************
	//}EXCxg
	//------------------------------------------------------------------------------------------------------
	//j[ƓAʂڍs悤ɂ
	public void mouseClicked(MouseEvent e) {
		//PlayerAEditorł𓚃[hȂ牽Ȃ
		if(frame.editF && frame.puzzleField.puzzleMode==MRPanel.MODE_EDIT){
			if(e.getModifiers()==MouseEvent.META_MASK || e.isShiftDown()){	//E{^܂̓VtgL[
				frame.puzzleField.deleteHintImage();			//ENbNŉ摜ij[ƓApanelłj
			}else{
				frame.puzzleField.inputHintImage(frame.fileIO);	//NbNŉ摜ǂݍ݁ij[ƓApanelłj
			}
		}
	}
	public void mousePressed(MouseEvent e) {
	}
	public void mouseReleased(MouseEvent e) {
	}
	public void mouseEntered(MouseEvent e) {
	}
	public void mouseExited(MouseEvent e) {
	}
}
