import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JSpinner;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.SpinnerNumberModel;

public class MRNewDialog extends JDialog implements ActionListener {
	//----------萔------------
	//
	static final int ROLE_NEW=0;
	static final int ROLE_CHANGE=1;
	//
	static final String LINE_SEPARATOR=System.getProperty("line.separator");
	//----------ϐ------------
	//Ăяo
	MRFrame frame;
	//
	JRadioButton radioNew=new JRadioButton("VK");
	JRadioButton radioChange=new JRadioButton("ύX");
	//element,item
	SpinnerNumberModel spinnerElem=new SpinnerNumberModel(MRData.DEF_ELEM,3,10,1);	//element 3-10
	SpinnerNumberModel spinnerItem=new SpinnerNumberModel(MRData.DEF_ITEM,4,20,1);	//item 4-20
	//type
	JCheckBox checkType=new JCheckBox("LE");
	JTextField fieldType=new JTextField("ʁiIXAXj",10);
	JTextArea areaType=new JTextArea("IX"+LINE_SEPARATOR+"X",3,3);
	//
	JButton buttonOk=new JButton("");
	JButton buttonCancel=new JButton("");
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public MRNewDialog(MRFrame frm){
		super(frm,"VK쐬EύX",true);
		frame=frm;
		//
		GridBagConstraints gbc=new GridBagConstraints();
		GridBagLayout gbl=new GridBagLayout();
		JLabel lbl;
		JSpinner spn;
		//1
		JPanel panelRadio=new JPanel();
		panelRadio.add(radioNew);
		panelRadio.add(radioChange);
		//2-1
		JPanel panelSize=new JPanel();
		panelSize.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"TCY"));	//g
		panelSize.setLayout(gbl);
		gbc.gridwidth=1;
		gbc.gridheight=1;
		gbc.anchor=GridBagConstraints.EAST;
		gbl.setConstraints(lbl=new JLabel("vfF"),gbc);
		panelSize.add(lbl);
		gbc.gridwidth=GridBagConstraints.REMAINDER;
		gbc.gridheight=1;
		gbc.anchor=GridBagConstraints.WEST;
		gbl.setConstraints(spn=new JSpinner(spinnerElem),gbc);
		panelSize.add(spn);
		gbc.gridwidth=1;
		gbc.gridheight=1;
		gbc.anchor=GridBagConstraints.EAST;
		gbl.setConstraints(lbl=new JLabel("vf̍ڐF"),gbc);
		panelSize.add(lbl);
		gbc.gridwidth=GridBagConstraints.REMAINDER;
		gbc.gridheight=GridBagConstraints.REMAINDER;
		gbc.anchor=GridBagConstraints.WEST;
		gbl.setConstraints(spn=new JSpinner(spinnerItem),gbc);
		panelSize.add(spn);
		//2-2
		JPanel panelType=new JPanel();
		panelType.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"OP4"));	//g
		panelType.setLayout(gbl);
		gbc.gridwidth=GridBagConstraints.REMAINDER;
		gbc.gridheight=1;
		gbc.anchor=GridBagConstraints.CENTER;
		gbl.setConstraints(checkType,gbc);
		panelType.add(checkType);
		gbc.gridwidth=1;
		gbc.gridheight=2;
		gbc.anchor=GridBagConstraints.EAST;
		gbl.setConstraints(lbl=new JLabel("F"),gbc);
		panelType.add(lbl);
		gbc.gridwidth=GridBagConstraints.REMAINDER;
		gbc.gridheight=2;
		gbc.anchor=GridBagConstraints.WEST;
		gbl.setConstraints(fieldType,gbc);
		panelType.add(fieldType);
		gbc.gridwidth=1;
		gbc.gridheight=GridBagConstraints.REMAINDER;
		gbc.anchor=GridBagConstraints.NORTHEAST;
		gbl.setConstraints(lbl=new JLabel("eF"),gbc);
		panelType.add(lbl);
		gbc.gridwidth=GridBagConstraints.REMAINDER;
		gbc.gridheight=GridBagConstraints.REMAINDER;
		gbc.anchor=GridBagConstraints.WEST;
		gbl.setConstraints(areaType,gbc);
		panelType.add(areaType);
		//2
		gbc.fill=GridBagConstraints.BOTH;	//ŏw肷anchorȂ
		JPanel panelCent=new JPanel();
		panelCent.setLayout(gbl);
		gbc.gridwidth=GridBagConstraints.REMAINDER;
		gbc.gridheight=1;
		gbl.setConstraints(panelSize,gbc);
		panelCent.add(panelSize);
		gbc.gridwidth=GridBagConstraints.REMAINDER;
		gbc.gridheight=GridBagConstraints.REMAINDER;
		gbl.setConstraints(panelType,gbc);
		panelCent.add(panelType);
		//3
		JPanel panelBtn=new JPanel();
		panelBtn.add(buttonOk);
		panelBtn.add(buttonCancel);
		//Reig
		Container cp=getContentPane();
		cp.add(panelRadio,BorderLayout.NORTH);
		cp.add(panelCent,BorderLayout.CENTER);
		cp.add(panelBtn,BorderLayout.SOUTH);
		//
		pack();							//TCY
		setLocationRelativeTo(null);	//ʂ̐^񒆂ɕ\
		//
		ButtonGroup radioGroup=new ButtonGroup();
		radioGroup.add(radioNew);
		radioGroup.add(radioChange);
		radioNew.setSelected(true);
		//
		checkType(false);
		//
		checkType.addActionListener(this);
		buttonOk.addActionListener(this);
		buttonCancel.addActionListener(this);
	}
	//******************************************************************************************************
	//\Õf[^K
	//------------------------------------------------------------------------------------------------------
	//VKEύX̐؂ւ
	public void setRole(int role){
		switch(role){
		case ROLE_NEW:
			radioNew.setSelected(true);
			break;
		case ROLE_CHANGE:
			radioChange.setSelected(true);
			break;
		}
	}
	public void setCurrentData(MRData data){
		spinnerElem.setValue(data.elemNum);
		spinnerItem.setValue(data.itemNum);
		//
		if(data.typeExp!=null) {
			checkType(true);
			//
			fieldType.setText(data.typeExp);
			areaType.setText("");
			for(int w=0;w<data.typeWords.length;w++) {
				areaType.append(data.typeWords[w]);
				areaType.append(LINE_SEPARATOR);
			}
		}else {
			checkType(false);
		}
		//ꂪȂtype͗̕\Ȃ
		pack();
	}
	private void checkType(boolean typeF) {
		checkType.setSelected(typeF);
		fieldType.setEnabled(typeF);
		areaType.setEnabled(typeF);
	}
	//******************************************************************************************************
	//{^Cxg
	//------------------------------------------------------------------------------------------------------
	public void actionPerformed(ActionEvent e) {
		Object object=e.getSource();
		if(object==buttonOk){
			//---------------------------܂͓ẽ`FbN
			//wTCY
			int eNum=Integer.parseInt(spinnerElem.getValue().toString());
			int iNum=Integer.parseInt(spinnerItem.getValue().toString());
			//
			String typeE=null;
			String[] typeWs=null;
			if(checkType.isSelected()){
				//
				typeE=fieldType.getText();
				if(typeE.equals("")) {
					frame.showErrorMessage("ʂ̐͂ł");
					return;
				}
				//
				typeWs=areaType.getText().split(LINE_SEPARATOR);
				if(typeWs.length==1){
					typeWs=typeWs[0].split("\n");	//JTextAreảśu\nv炵(LINE_SEPARATORł͑ʖ)
				}
				if(typeWs.length<2) {
					frame.showErrorMessage("ʂ̓esĂ܂");
					return;
				}
			}
			//---------------------------f[^ւ̌x
			if(radioChange.isSelected()) {
				if(frame.puzzleField.puzzleData.checkDataDelete(eNum, iNum, typeE, typeWs)) {
					int ret=JOptionPane.showConfirmDialog(frame, "f[^邩܂B"+LINE_SEPARATOR+"s܂H", "",JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE);
					if(ret==JOptionPane.NO_OPTION) {
						return;
					}
				}
			}
			//---------------------------
			setVisible(false);
			//---------------------------
			if(radioNew.isSelected()){					//VK
				frame.newPuzzle(eNum, iNum,typeE,typeWs);
			}else/* if(radioChange.isSelected())*/{		//ύX
				frame.changePuzzle(eNum, iNum, typeE,typeWs);
			}
		}else if(object==buttonCancel){
			setVisible(false);
		}else if(object==checkType){
			fieldType.setEnabled(checkType.isSelected());
			areaType.setEnabled(checkType.isSelected());
		}
	}
}
