import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Graphics;
import java.awt.GridLayout;
import java.awt.Image;
import java.awt.Label;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.jar.Attributes;
import java.util.jar.JarEntry;
import java.util.jar.JarFile;
import java.util.jar.JarOutputStream;
import java.util.jar.Manifest;

import javax.imageio.ImageIO;
import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;

public class MROutPlayerDialog extends JDialog implements ActionListener {
	//----------萔------------
	//t@C̍ږw
	static final String NO_STR="no";
	//Player̕ۑt@C
	static final String CREDIT_FILE="info.txt";
	static final String MATRIX_FILE="matrix.csv";
	static final String HINT_TXT_FILE="hint_txt.txt";
	static final String HINT_IMG_FILE="hint_img.png";
	//PlayerɃRs[NX
	static final String[] CLASS_COPY=new String[]{
			"MRFrame.class","MRPanel.class","MRData.class","MRElement.class",
			"MRNewDialog.class","MRSaveDialog.class","MRSizeDialog.class",
			"MRFileIO.class","MRCoordinate.class","MRError.class","MRAnalyze.class",
			"MRElemAnswerDialog.class","MRElemEditDialog.class",
			"MRAnswerTableDialog.class","MRAnswerTablePanel.class","ImageOutputable.class",
			"MRHintTextDialog.class","MRHintImageDialog.class","MRHintImagePanel.class",
			"MROutPlayerDialog.class","MRInfoDialog.class","MRInfoPanel.class",
			};
	//
	//----------ϐ------------
	//
	MRFrame frame;
	//
	JFileChooser chooser;
	//
	JTextField fieldPath=new JTextField(15);
	JButton buttonPath=new JButton("st@C");
	//
	JTextField fieldTitle=new JTextField(18);
	MRInfoPanel infoPanel=new MRInfoPanel(true);	//ҏW\
	//
	JRadioButton radioProceedOn=new JRadioButton("on");
	JRadioButton radioProceedOff=new JRadioButton("off",true);
	JRadioButton radioCheckOn=new JRadioButton("on",true);
	JRadioButton radioCheckOff=new JRadioButton("off");
	//
	JButton buttonOk=new JButton("o");
	JButton buttonCancel=new JButton("");
	//o͐
	File targetFile;
	//Playeȑt@C̃f[^iNɎ擾ĂKXQƂj
	//	IvV
	boolean infoOptProceed;	//0.qg\
	boolean infoOptCheck;	//1.𓚕\
	//	҂ɂw
	String infoFile;		//2.g̃t@Cigqj
	String infoTitle;		//3.^Cg
	//4.ҁiinfoDialogŏj
	//5ȉ.RgiinfoDialogŏj
	//
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public MROutPlayerDialog(MRFrame frm){
		super(frm,"st@Cɏo",true);
		frame=frm;
		//vOfBNglɂč쐬
		chooser=new JFileChooser(".");
		//ڂ͕ҏWłȂ
		fieldPath.setEditable(false);
		//
		//
		JPanel panelExe=new JPanel();	//1-1
		panelExe.add(fieldPath);
		panelExe.add(buttonPath);
		//
		ButtonGroup radioGroupHint=new ButtonGroup();
		radioGroupHint.add(radioProceedOn);
		radioGroupHint.add(radioProceedOff);
		ButtonGroup radioGroupAnswer=new ButtonGroup();
		radioGroupAnswer.add(radioCheckOn);
		radioGroupAnswer.add(radioCheckOff);
		//
		JPanel hintPanel=new JPanel();		//1-2-1
		hintPanel.add(new Label("𓚂i߂F"));
		hintPanel.add(radioProceedOn);
		hintPanel.add(radioProceedOff);
		JPanel answerPanel=new JPanel();	//1-2-2
		answerPanel.add(new Label("𓚔F"));
		answerPanel.add(radioCheckOn);
		answerPanel.add(radioCheckOff);
		JPanel optionPanel=new JPanel();	//1-2
		optionPanel.setLayout(new GridLayout(2,1));
		optionPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"IvV"));	//g
		optionPanel.add(hintPanel);
		optionPanel.add(answerPanel);
		//
		JPanel functionPanel=new JPanel();	//1
		functionPanel.setLayout(new BorderLayout());
		functionPanel.add(panelExe,BorderLayout.NORTH);
		functionPanel.add(optionPanel,BorderLayout.CENTER);
		//
		JPanel panelTitle=new JPanel();	//2-1
		panelTitle.add(new JLabel("^CgF"));
		panelTitle.add(fieldTitle);
		//
		JPanel panelInfo=new JPanel();	//2
		panelInfo.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),""));	//g
		panelInfo.setLayout(new BorderLayout());
		panelInfo.add(panelTitle,BorderLayout.NORTH);
		panelInfo.add(infoPanel,BorderLayout.CENTER);
		//
		JPanel panelButton=new JPanel();	//3
		panelButton.add(buttonOk);
		panelButton.add(buttonCancel);
		//Reig
		Container cp=getContentPane();
		cp.add(functionPanel,BorderLayout.NORTH);
		cp.add(panelInfo,BorderLayout.CENTER);
		cp.add(panelButton,BorderLayout.SOUTH);
		//TCY
		pack();
		//
		setLocationRelativeTo(null);	//ʂ̐^񒆂ɕ\
		//
		buttonPath.addActionListener(this);
		buttonOk.addActionListener(this);
		buttonCancel.addActionListener(this);
		//o͐
		targetFile=null;
	}
	//******************************************************************************************************
	//{^̑Cxg
	//------------------------------------------------------------------------------------------------------
	public void actionPerformed(ActionEvent e) {
		Object object=e.getSource();
		if(object==buttonPath){				//jarw
			getTargetJar();
		}else if(object==buttonOk){
			if(checkDataConform()){
				setVisible(false);
				//Playero
				outputPlayer();
			}
		}else if(object==buttonCancel){
			setVisible(false);
		}
	}
	//******************************************************************************************************
	//o͐擾
	//------------------------------------------------------------------------------------------------------
	private void getTargetJar(){
		chooser.setSelectedFile(targetFile);
		chooser.setDialogTitle("st@C(*.jar)o͐I");
		int ret=chooser.showDialog(this, "I");
		if(ret==JFileChooser.APPROVE_OPTION){
			targetFile=chooser.getSelectedFile();
			//gqtĂȂΕt
			targetFile=MRFileIO.addExtension(targetFile, "jar");
			//
			fieldPath.setText(targetFile.getPath());
		}
	}
	//******************************************************************************************************
	//	t@C
	//------------------------------------------------------------------------------------------------------
	private String getInfoString() {
		StringBuffer out=new StringBuffer();
		//0.qg\
		if(radioProceedOn.isSelected()){
			addStr(out,"yes");
		}else{
			addStr(out,NO_STR);
		}
		//1.𓚕\
		if(radioCheckOn.isSelected()){
			addStr(out,"yes");
		}else{
			addStr(out,NO_STR);
		}
		//
		//2.t@Cigqj
		String tmpStr=targetFile.getName();
		out.append( tmpStr.substring(0,tmpStr.indexOf(".")) ).append( System.getProperty("line.separator") );
		//3.^Cg
		addStr(out,fieldTitle.getText());
		//4.
		addStr(out,infoPanel.getAuther());
		//5.Rgis͂̂܂܁j
		addStr(out,infoPanel.getComment());
		//
		return out.toString();
	}
	static private void addStr(StringBuffer strBuf,String adStr){
		final String br=System.getProperty("line.separator");
		//
		if(adStr.length()==0){
			strBuf.append(NO_STR).append(br);
		}else{
			strBuf.append(adStr).append(br);
		}
	}
	//******************************************************************************************************
	//̓f[^̐`FbN
	//------------------------------------------------------------------------------------------------------
	private boolean checkDataConform(){
		if(targetFile==null){
			frame.showErrorMessage("o͐w肵ĂB");
			return false;
		}
		//qgeLXg
		if(frame.puzzleField.hintTextDialog.getHintText().equals("")){
			frame.showErrorMessage("qgeLXg͂łB");
			return false;
		}
		//
		if(radioCheckOn.isSelected()){
			//OX\̃G[͕uĂ
			//𓚕\iG[܂ށj(܂)
			if(!frame.puzzleField.puzzleData.checkAnswerTableCompleted()){
				frame.showErrorMessage("𓚔Lɂɂ́A𓚕\Kv܂B"+System.getProperty("line.separator")+"G[E̔肪cĂĂ܂B");
				return false;
			}
		}
		//
		return true;
	}
	//******************************************************************************************************
	//	Playt@Co
	//------------------------------------------------------------------------------------------------------
	//JARŁAN\ȃAvP[Vo͂
	private void outputPlayer(){
		try {
			//}jtFXg쐬
			Manifest manifest=new Manifest();
			Attributes attributes=manifest.getMainAttributes();
			attributes.put(Attributes.Name.MANIFEST_VERSION, "1.0");
			attributes.put(Attributes.Name.MAIN_CLASS, "MRPanel");	//Play̏ꍇPanelmain					***[main class name]***
			//̃}jtFXgJAR쐬
			JarOutputStream jos=new JarOutputStream(new BufferedOutputStream(new FileOutputStream(targetFile)),manifest);
			//
			//	NX
			copyPlayer(jos,CLASS_COPY);										//NXJARɃRs[
			//	0.
			makeTextFile(getInfoString(),jos,CREDIT_FILE);					//t@CJARɍ쐬
			//	1.OX\(Matrix)(inconstantmark͋ɂāAjarOsolutiont@Cň)
			makeTextFile(frame.puzzleField.getSaveString(false),jos,MATRIX_FILE);	//Z[ut@CJARɍ쐬
			//	2.qgeLXg
			makeTextFile(frame.puzzleField.hintTextDialog.getHintText(),jos,HINT_TXT_FILE);	//qgeLXgJARɍ쐬
			//	3.qg摜
			Image hintI=frame.puzzleField.hintImageDialog.getImage();
			if(hintI!=null) {
				copyImage(hintI,jos,HINT_IMG_FILE);								//qg摜JARɃRs[
			}
			//
			jos.close();
			//
			frame.showInfoMessage("o͂܂", "");
		} catch (IOException ioe) {
			frame.showErrorMessage("o͒ɃG["+System.getProperty("line.separator")+ioe.toString());
		}

	}
	static private void copyPlayer(JarOutputStream jos,String[] targetClass) throws IOException{
		//t@Cog
		JarFile jarSelf=new JarFile(System.getProperty("user.dir")+System.getProperty("file.separator")+"MRPlayer.jar");	//***[self jar name]***
		//
		for(int c=0;c<targetClass.length;c++) {
			JarEntry playerEntryFrom=new JarEntry(targetClass[c]);
			//
			BufferedInputStream bis=new BufferedInputStream(jarSelf.getInputStream(playerEntryFrom));
			//
			JarEntry playerEntryTo=new JarEntry(targetClass[c]);
			jos.putNextEntry(playerEntryTo);
			//
			int b;
			while((b=bis.read())!=-1){
				jos.write((byte)b);
			}
			//
			jos.closeEntry();
			bis.close();
		}
		//
		jarSelf.close();
	}
	static private void makeTextFile(String info,JarOutputStream jos,String targetName) throws IOException{
		//w̃t@CŃGg[ǉ
		JarEntry settingEntry=new JarEntry(targetName);	//
		jos.putNextEntry(settingEntry);
		//w̕
		jos.write(info.getBytes());
		//
		jos.closeEntry();
	}
	private void copyImage(Image img,JarOutputStream jos,String targetName) throws IOException{
		//摜t@C̎ށigqj
		String imageType;
		int period=targetName.lastIndexOf(".");
		if(period!=-1 && period<targetName.length()-1) {	//gq
			imageType=targetName.substring(period+1);
		}else {
			imageType="jpg";	//s̏ꍇ
		}
		//
		//ۑp摜
		BufferedImage bufImage;
		if(imageType.equals("gif")){	//GIFɑΉ邽 TYPE_INT_ARGB ɂ
			bufImage=new BufferedImage(img.getWidth(this),img.getHeight(this),BufferedImage.TYPE_INT_ARGB);
		}else{							//
			bufImage=new BufferedImage(img.getWidth(this),img.getHeight(this),BufferedImage.TYPE_INT_RGB);
		}
		Graphics g=bufImage.getGraphics();
		//g.setColor(Color.WHITE);
		//g.fillRect(0,0,bufImage.getWidth(),bufImage.getHeight());
		g.drawImage(img, 0, 0, this);
		//摜f[^o
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		ImageIO.write(bufImage, imageType, baos);
		baos.flush();
		byte[] imageInByte = baos.toByteArray();
		baos.close();
		//
		InputStream is = new ByteArrayInputStream(imageInByte);		//
		BufferedInputStream bis=new BufferedInputStream(is);
		//w̃t@CŃGg[ǉ
		JarEntry outEntry=new JarEntry(targetName);	//
		jos.putNextEntry(outEntry);
		//摜f[^o
		int b;
		while((b=bis.read())!=-1){
			jos.write((byte)b);
		}
		//
		jos.closeEntry();
		bis.close();
	}
	//******************************************************************************************************
	//	Playt@Cǂݍ
	//------------------------------------------------------------------------------------------------------
	//0.t@C
	public boolean getInfoFromPlayer(MRInfoDialog infoDlg){
		//ǂݍ
		String[] infoStr=readTextFromPlayer(CREDIT_FILE);
		if(infoStr==null){
			frame.showErrorMessage("Playeȑt@C݂܂");
			return false;	//ǂݍ݃G[
		}
		if(infoStr.length<6){
			frame.showErrorMessage("Playeȑt@CԈĂ܂");
			return false;	//ss
		}
		//f[^ȅ
		//	0.𓚐is
		if(infoStr[0].equals(NO_STR)){
			infoOptProceed=false;
		}else{
			infoOptProceed=true;
		}
		//	1.𓚔
		if(infoStr[1].equals(NO_STR)){
			infoOptCheck=false;
		}else{
			infoOptCheck=true;
		}
		//	2.t@Cigqj
		infoFile=infoStr[2];
		//	3.^Cg
		if(infoStr[3].equals(NO_STR)){
			infoTitle=infoStr[2];	//wȂt@CK
		}else{
			infoTitle=infoStr[3];
		}
		//	4.	5ȍ~.RgiinfoDialogɓn\j
		StringBuilder com=new StringBuilder();
		com.append(infoStr[5]);				//Rg1sځANO_STRȂ
		for(int c=6;c<infoStr.length;c++){	//Rg2sڈȍ~
			com.append(System.getProperty("line.separator")).append(infoStr[c]);
		}	//iŌɉstȂ悤ɂĂj
		infoDlg.setInfoData(infoStr[4], com.toString());
		//
		//I
		return true;
	}
	//1.OX\(Matrix),𓚕\
	public String[] getMatrixDataFromPlayer(){
		return readTextFromPlayer(MATRIX_FILE);
	}
	//2.qgeLXg
	public String getHintTextFromPlayer(){
		String[] hStr=readTextFromPlayer(HINT_TXT_FILE);
		if(hStr!=null){
			StringBuilder sb=new StringBuilder();
			for(int s=0;s<hStr.length;s++){
				sb.append(hStr[s]).append(System.getProperty("line.separator"));
			}
			return sb.toString();
		}else{
			frame.showErrorMessage("qgeLXg܂łB");
			return "";
		}
	}
	//3.qg摜
	public Image getHintImageFromPlayer(){
		if( existHintImageInPlayer() ){	//݂
			return (new ImageIcon(getClass().getResource(HINT_IMG_FILE))).getImage();
		}else{							//݂Ȃ
			return null;
		}
	}
	private boolean existHintImageInPlayer(){
		try{
			JarFile jarFile=new JarFile(System.getProperty("user.dir")+System.getProperty("file.separator")+infoFile+".jar");
			for (Enumeration<JarEntry> e = jarFile.entries(); e.hasMoreElements();) {
				JarEntry entry = e.nextElement();
				if(entry.getName().equals(HINT_IMG_FILE)){
					jarFile.close();
					return true;
				}
			}
			//
			jarFile.close();
			return false;
		}catch(IOException ioe){
			frame.showErrorMessage("qg摜̊mFŃG["+System.getProperty("line.separator")+ioe.toString());
			return false;
		}
	}
	//Playerɂ鎩𓚕ۑ(solution)̃t@C
	public String getSolutionName(){
		return infoFile+MRSaveDialog.NAME_SOLUTION;
	}
	//JAR̃eLXgt@Cǂݍ݁iėpj
	private String[] readTextFromPlayer(String target){			//
		try{
			//ݒt@Cǂݍ
			String ret[];
			//jar̃eLXgt@C̓̓Xg[𓾂
			InputStream is=getClass().getResourceAsStream(target);	//̃NX璼ړǂݍ
			//StreamiÂnjReaderiVnj֕ϊ
			BufferedReader br=new BufferedReader(new InputStreamReader(is));
			//
			ArrayList<String> array=new ArrayList<String>();
			String str;
			while( (str=br.readLine())!=null ){
				array.add(str);
			}
			//
			br.close();
			//
			ret=new String[array.size()];
			for(int i=0;i<ret.length;i++){
				ret[i]=array.get(i);
			}
			//
			return ret;
		}catch(IOException ioe){
			frame.showErrorMessage("PlayereLXgt@C̓ǂݍ݂ŃG["+System.getProperty("line.separator")+ioe.toString());
			return null;
		}
	}
}
