import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.print.PageFormat;
import java.awt.print.Printable;
import java.awt.print.PrinterException;

import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

public class MRPanel extends JPanel
		implements MouseListener, MouseMotionListener, KeyListener, ComponentListener, Printable, ImageOutputable{
	//******************************************************************************************************
	//Niplaypj
	//------------------------------------------------------------------------------------------------------
	public static void main(String[] args) {
		MRFrame frame=new MRFrame(false);	//false
		frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);	//E~ł͉Ȃiŏj
		frame.setVisible(true);
		frame.setLocationRelativeTo(null);	//ʂ̐^񒆂ɕ\
	}
	//----------萔------------
	//ipuzzleModej
	static final int MODE_ANSWER=0;
	static final int MODE_EDIT=1;
	//
	static final int DEF_CELL=20;
	static final int DEF_FONT_DIFF=3;
	//(draged)
	static final int DRG_POS=0;		//()̈w
	static final int DRG_CENT_X=1;	//(center)}Xxʒu
	static final int DRG_CENT_Y=2;	//(center)}Xyʒu
	static final int DRG_EDGE_BFR=1;	//(edge)element index
	static final int DRG_EDGE_AFT=2;	//(edge)element index
	//static final int DRG_ALL=3;
	//(draged[DRG_POS])
	//static final int DRG_POS_HOR=0;		//edge(horizontal)=MRCoordinate.CO_HOR
	//static final int DRG_POS_VER=1;		//edge(vertical)=MRCoordinate.CO_VER
	static final int DRG_POS_CENT=2;		//center
	//----------ϐ------------
	//pY{
	MRData puzzleData;
	//\Wn
	MRCoordinate co;
	//
	MRAnalyze analyze;
	//
	//ʃt[
	MRHintTextDialog hintTextDialog;
	MRHintImageDialog hintImageDialog;
	MRAnswerTableDialog answerTableDialog;
	//
	MRElemEditDialog elemEditDialog;	//element̖f[^(edit[ĥ)
	MRElemAnswerDialog elemAnsDialog;	//element̉𓚓
	//
	int puzzleMode;
	//
	int	cellSize;		//ڂ̃TCY
	int	baseX,baseY;	//`挴_
	//
	//\tO
	boolean errorViewFlag;
	boolean cursorViewFlag;
	boolean answerViewFlag;
	//
	boolean autoXAddFlag;
	boolean autoXDelFlag;
	//-------------------------------------J[\
	//drag̏i[(centeredgeœeႤ)
	int[/*DRG_ALL*/] draged;				//edgȅꍇAelementɃJ[\
	//elementIJ[\(edit[ĥ)
	int sel;								//element index
	//}EXʒuJ[\
	int[/*EDG_ALL or SBS_ALL*/] mouseOn;	//MRCoordinate.getSubstance()̖߂l
	//-------------------------------------
	//t[TCŶ
	JScrollPane scrollEdge;
	Dimension edgeMargin;
	//
	//pY{̂̃f[^ύX肩ǂijǑxpj
	boolean changed;
	MRFrame frame;	//^CgύXpAG[bZ[W\
	//
	boolean firstF;	//񏈗p̃tO
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public MRPanel(MRFrame frm){
		//
		puzzleData=new MRData();
		co=new MRCoordinate(puzzleData);
		analyze=new MRAnalyze(puzzleData,frm);
		//ʃt[̍쐬̂݁i\---^C~OŁj
		hintTextDialog=new MRHintTextDialog(frm,this);
		hintImageDialog=new MRHintImageDialog(frm,null);
		answerTableDialog=new MRAnswerTableDialog(frm,puzzleData);
		//
		elemEditDialog=new MRElemEditDialog(frm,puzzleData);
		elemAnsDialog=new MRElemAnswerDialog(frm,puzzleData);
		//
		puzzleMode=MODE_ANSWER;
		//
		cellSize=DEF_CELL;
		//
		//\tO
		errorViewFlag=true;
		cursorViewFlag=true;
		answerViewFlag=false;
		//
		autoXAddFlag=true;
		autoXDelFlag=true;
		//------------------J[\
		formatCursolPos();
		//------------------
		//œKTCYE`挴_̒
		setPreferredPanelSize();
		//
		changed=false;	//łsetChangedȂ
		frame=frm;
		//Cxg̐ݒ
		addMouseListener(this);
		addMouseMotionListener(this);
		addKeyListener(this);
		addComponentListener(this);
		//ʃt[̕\
		//
		firstF=true;
	}
	//t[TCŶ߃XN[̈Ƃ̃TCY߂˂΂Ȃ
	public void setScrollEdge(JScrollPane scroll){
		scrollEdge=scroll;
		//
		edgeMargin=new Dimension(scrollEdge.getWidth()-getWidth(),scrollEdge.getHeight()-getHeight());
		if(edgeMargin.width==0 || edgeMargin.height==0){
			edgeMargin=new Dimension(3,3);		//炩̗RœȂWindowsł̒lɐݒ
		}
	}
	//******************************************************************************************************
	// VKEύX
	//------------------------------------------------------------------------------------------------------
	//wTCYŐVpY쐬
	public void formatPuzzle(int eNum,int iNum,String typeE,String[] typeWs){
		//
		puzzleData.formatPuzzle(eNum, iNum,typeE,typeWs);
		//e_CAOŕύXɓK
		answerTableDialog.refreshViewAll();						//element,itemς
		hintTextDialog.setHintText("");	//
		hintImageDialog.deleteImage();	//
		elemEditDialog=new MRElemEditDialog(frame,puzzleData);	//itemς
		elemAnsDialog.adaptTypeWords();
		//J[\
		formatCursolPos();
		//Wݒ肵Ȃ
		setCoordinate();
		//
		//f[^ύX͂܂Ȃ
		setChanged(false);
		//
		requestFocus();	//ȂĂ悤
	}
	//wTCYɕύX
	public void changePuzzle(int eNum,int iNum,String typeE,String[] typeWs){
		//
		puzzleData.changePuzzle(eNum, iNum,typeE,typeWs);
		//e_CAOŕύXɓK
		answerTableDialog.refreshViewAll();						//element,itemς
		//hintTextDialog	̂܂
		//hintImageDialog	̂܂
		elemEditDialog=new MRElemEditDialog(frame,puzzleData);	//itemς
		elemAnsDialog.adaptTypeWords();
		//J[\
		formatCursolPos();
		//Wݒ肵Ȃ
		setCoordinate();
		//
		//f[^ύX
		setChanged(true);
		//
		requestFocus();	//ȂĂ悤
	}
	private void formatCursolPos(){
		draged=null;
		sel=MRData.NO_DATA;
		mouseOn=null;
	}
	//Wݒ
	public void setCoordinate(){
		//p̍W
		co.edgeHeight=puzzleData.getEdgeHeight(getCellSize());
		co.edgeWidth=puzzleData.getEdgeWidth();
		co.setCoordinate();
		//œKTCYE`挴_̒
		setPreferredPanelSize();
	}
	//******************************************************************************************************
	//ݒύX
	//------------------------------------------------------------------------------------------------------
	public void changePuzzleMode(int mode){
		puzzleMode=mode;
		//[hint text]
		if(mode==MODE_EDIT){
			hintTextDialog.setEditable(true);
		}else{	//MODE_ANSWER
			hintTextDialog.setEditable(false);
		}
		//[hint image]
		hintImageDialog.repaint();
		//L[{[ĥ߃tH[JX𓾂
		requestFocus();
		//
		repaint();
	}
	public void setErrorViewFlag(boolean f){
		errorViewFlag=f;
		//
		repaint();
	}
	public void setCursorViewFlag(boolean f){
		cursorViewFlag=f;
		//
		repaint();
	}
	public void setAnswerViewFlag(boolean f){
		answerViewFlag=f;
		//
		repaint();
	}
	public void setAutoXAddFlag(boolean f){
		autoXAddFlag=f;
	}
	public void setAutoXDelFlag(boolean f){
		autoXDelFlag=f;
	}
	public boolean checkChanged(){
		return changed;
	}
	public void setChanged(boolean f){
		changed=f;
		//^CgŕύX̗LiZ[uA[hAVK̎ɂ͏dȂ邪j
		frame.setTitleString();
	}
	//******************************************************************************************************
	//Frame̕ҏWj[
	//------------------------------------------------------------------------------------------------------
	public void fillCross(){	//uOsXŖ߂v
		if(puzzleData.fillCross()){
			//
			setChanged(true);
			//
			repaint();
		}else{
			frame.showInfoMessage("ύX܂", "");
		}
	}
	public void fillCircle(){	//uPƋ}XOŖ߂v
		if(puzzleData.fillCircle()){
			//
			setChanged(true);
			//
			repaint();
		}else{
			frame.showInfoMessage("ύX܂", "");
		}
	}
	public void deleteMatrixAnswer(){	//uOX\ 𓚏v
		puzzleData.deleteMatrixAnswer();
		//
		setChanged(true);
		//
		repaint();
	}
	public void formatAnswerTable(){	//u𓚕\ v
		puzzleData.formatAnswerTable();
		//
		setChanged(true);
		//
		getAnsTablePanel().repaint();
	}
	public void reflectMatrixToAnswer(){	//uf(OX\->𓚕\)v
		//
		int ret=JOptionPane.showConfirmDialog(frame,"݂̉𓚕\̃f[^͍폜܂B"+System.getProperty("line.separator")+"܂H",
				"mF",JOptionPane.YES_NO_OPTION,JOptionPane.WARNING_MESSAGE);
		if(ret==JOptionPane.YES_OPTION){
			//
			String msg=puzzleData.reflectMatrixToAnswer();
			//G[bZ[W\Oɍĕ`悵Ă
			getAnsTablePanel().repaint();
			//G[Ȃ烁bZ[W\
			if(msg!=null){	frame.showErrorMessage(msg);	}
			//G[̗Lɂ炸ύXƂisÕG[`FbNňꍇ͕ύXȂj
			setChanged(true);
		}
	}
	public void reflectAnswerToMatrix(){	//uf(𓚕\->OX\)v
		//
		int ret=JOptionPane.showConfirmDialog(frame,"݂OX\̃f[^͍폜܂B"+System.getProperty("line.separator")+"܂H",
				"mF",JOptionPane.YES_NO_OPTION,JOptionPane.WARNING_MESSAGE);
		if(ret==JOptionPane.YES_OPTION){
			//
			String msg=puzzleData.reflectAnswerToMatrix();
			if(msg==null){	//I
				//
				setChanged(true);
				//
				repaint();
			}else{			//G[
				frame.showErrorMessage(msg);
				//î͎sÕG[`FbN݂̂Ȃ̂ŁAύXōĕ`svj
			}
		}
	}
	public void proceedAnswer(){		//u𓚂i߂v
		//
		if(analyze.analyze()){
			//ύXierrorȂj
			setChanged(true);
			//
			repaint();
		}else{
			//ύXȂ
			frame.showInfoMessage("ȏ͐isł܂B", "");
		}
	}
	public void removeContradiction(){
		puzzleData.removeContradictionAll();
		//ύXȂ
		//OX\(matrix)answerTable\̉\̂ŁAƂĕ`
		repaint();
		getAnsTablePanel().repaint();
	}
	public void checkAnswer(){			//u v
		//
		analyze.checkAswer();
	}
	//
	public MRAnswerTablePanel getAnsTablePanel(){
		return answerTableDialog.answerTablePanel;
	}
	//******************************************************************************************************
	//}XTCY
	//------------------------------------------------------------------------------------------------------
	public int getCellSize(){
		return cellSize;
	}
	public void setCellSize(int size){
		//[matrix]
		cellSize=size;
		//
		setPreferredPanelSize();
		//
		//[answer table](setPreferredPanelSize()Ă)
		getAnsTablePanel().setCellSize(size);
		//[hint text]
		hintTextDialog.setFontSize(size-DEF_FONT_DIFF*2);
	}
	//}XTCYύXɃt[Ă΂AꎞIɃpl̃TCY}X̃TCYɍ킹i܂t[̃TCY͕ςj
	public void adjustPanelSize(){
		//[matrix]
		//XN[o[\Ă	[XN[̈pl]<[œKplTCY]
		//Ȃ							[XN[̈pl]>[œKplTCY]
		int w=Math.max(scrollEdge.getWidth()-edgeMargin.width,getPreferredSize().width);
		int h=Math.max(scrollEdge.getHeight()-edgeMargin.height,getPreferredSize().height);
		//pl̃TCYύXiXN[̈pl傫ȂΎŃXN[o[oj
		setSize(w,h);
		//
		//[answer table]
		getAnsTablePanel().adjustPanelSize();
		//[hint text]
		//ȂĂ
	}
	//******************************************************************************************************
	//œKTCYE`挴_̒
	//------------------------------------------------------------------------------------------------------
	//œKplTCYݒ
	private void setPreferredPanelSize(){
		int preferredWidth=cellSize*((puzzleData.elemNum-1)*puzzleData.itemNum+co.edgeHeight+2 );
		int preferredHeight=cellSize*((puzzleData.elemNum-1)*puzzleData.itemNum+co.edgeHeight+2 );
		setPreferredSize(new Dimension(preferredWidth,preferredHeight));
		//`挴_ݒ
		setPaintBasePoint();
	}
	//`挴_iplTCYύXPƂŌĂ΂j
	private void setPaintBasePoint(){
		//
		Dimension d=getPreferredSize();
		if(getWidth()<=d.width){
			baseX=(cellSize*(co.edgeHeight+1));
		}else{
			baseX=(cellSize*(co.edgeHeight+1))+( (getWidth()-d.width)>>1 );
		}
		if(getHeight()<=d.height){
			baseY=(cellSize*(co.edgeHeight+1));
		}else{
			baseY=(cellSize*(co.edgeHeight+1))+( (getHeight()-d.height)>>1 );
		}
		//ōĕ`悷̂őł͂ȂĂ
		repaint();
	}
	//œKplTCYɑ΂āApl̕\Ă镔ǂꂾTCYߏ肩Ԃ
	//it[Ă΂At[ǂꂾ߂΃XN[o[\ɂނ̔fɎgj
	public Dimension getSizeDifference(){
		//XN[o[\Ă	[pl̈]>[XN[̈pl]
		//Ȃ							[pl̈]<[XN[̈pl]
		int w=Math.min(getWidth(),scrollEdge.getWidth()-edgeMargin.width)-getPreferredSize().width;
		int h=Math.min(getHeight(),scrollEdge.getHeight()-edgeMargin.height)-getPreferredSize().height;
		return new Dimension( w , h );
	}
	//Tut[̈ʒuƕ\
	public void setDialogPos(boolean viewFlag){
		Point frmPos=frame.getLocation();
		//CEBhẺEƉɕt
		hintTextDialog.setLocation(frmPos.x+frame.getWidth(),frmPos.y);
		hintImageDialog.setLocation(frmPos.x+frame.getWidth(),frmPos.y+frame.getHeight());
		answerTableDialog.setLocation(frmPos.x,frmPos.y+frame.getHeight());
		if(viewFlag){	//N̏񏈗ŕ\
			showHintTextDialog(true);
			if(frame.editF){	//Editor
				showHintImageDialog(true);
				showAnswerTableDialog(true);
			}else{				//Player
				if(hintImageDialog.getImage()!=null){
					showHintImageDialog(true);	//qg摜Ε\
				}								//ȂΔ\
				//AnswerTable͔\
			}
		}
	}
	//摜ۑ̂߂̕`挴_ił͕`XP[ς\̂ňČvZj
	private Point getOutputBasePoint(int cell){
		return new Point(cell*(1+co.edgeHeight),cell*(1+co.edgeHeight));
	}
	//̕cellɎ܂邩(edgeHeight,ansTablěvZɎg)
	public static int convertFontNumToCellNum(int fontN,int cell){
		return (fontN*(cell-MRPanel.DEF_FONT_DIFF*2))/cell+1;	//+1(Z̐؂̂ĕĂ)
	}
	//******************************************************************************************************
	//`
	//------------------------------------------------------------------------------------------------------
	public void paintComponent(Graphics g){
		super.paintComponent(g);	//KviꂪȂƔwiFœhԂȂj
		//`挴_w肵ĕ`悳
		paintField(g,baseX,baseY,cellSize);
	}
	//摜ۑ̕`i`挴_͔Ֆʂɋl߂WA`XP[͓j
	public void paintGraphic(Graphics g){
		Point base=getOutputBasePoint(cellSize);
		paintField(g, base.x, base.y,cellSize);
	}
	//̕`i`挴_͔Ֆʂɋl߂WA`XP[͈\̈ɍ킹ďkj
	public int print(Graphics g, PageFormat fmt, int index) throws PrinterException {
		if(index>0){	//y[W1y[WɌŒ
			return NO_SUCH_PAGE;
		}else{
			//\ȍʒu
			int x=(int)fmt.getImageableX();
			int y=(int)fmt.getImageableY();
			g.translate(x,y);
			//`XP[𒲐
			double pageW=fmt.getImageableWidth();
			double pageH=fmt.getImageableHeight();
			int fieldW=getPreferredSize().width;
			int fieldH=getPreferredSize().height;
			double ratioW=pageW/fieldW;		//̔{
			double ratioH=pageH/fieldH;		//̔{
			double ratio=1;
			int cell;
			if(ratioW<1 || ratioH<1){		//ƍǂ炩łk̕Kv
				ratio=(ratioW<ratioH)?ratioW:ratioH;	//k˂΂ȂȂ{I
				//
				cell=(int)(cellSize*ratio);
			}else{							//Sk̕KvȂ΂̂܂
				cell=cellSize;
			}
			//
			Point base=getOutputBasePoint(cell);	//k`XP[Ŏ擾
			paintField(g,base.x,base.y,cell);
			//
			return PAGE_EXISTS;
		}
	}
	//ėp̕`惁\bhi摜ۑɂgj
	private void paintField(Graphics g,int bx,int by,int cell){
		//N̏񏈗
		if(firstF){
			//CETuEBhE̒i\iKłȂƂȂ悤j
			frame.fitFrameSize(true,true);	//Ct[̓pYTCYɍ킹
			//
			//̈̂
			firstF=false;
		}
		//
		//----------------------------wi
	    g.setColor(Color.white);
		g.fillRect(bx-cell*(co.edgeHeight+1), by-cell*(co.edgeHeight+1), getPreferredSize().width, getPreferredSize().height);
		//----------------------------
		g.setFont(new Font( null, Font.PLAIN, cell-DEF_FONT_DIFF*2));
		if(answerViewFlag){
			g.setColor(Color.CYAN);
			//	[mark]
			//element 0
			for(int e=1;e<puzzleData.elemNum;e++){	//[1]-
				for(int i=0;i<puzzleData.itemNum;i++){
					int iH=puzzleData.ansTable[i][e-1];
					if(iH!=MRData.NO_DATA){
						g.fillRect(bx+cell*co.sbsToCrd[e][iH][MRCoordinate.CO_HOR],by+cell*co.sbsToCrd[0][i][MRCoordinate.CO_VER],cell,cell);
					}
				}
			}
			//
			for(int eL=puzzleData.elemNum-1;eL>=2;eL--){	//
				//element eL
				for(int eS=1;eS<eL;eS++){	//[1]-[eL]
					for(int i=0;i<puzzleData.itemNum;i++){
						int iH=puzzleData.ansTable[i][eS-1];
						int iV=puzzleData.ansTable[i][eL-1];
						if(iH!=MRData.NO_DATA && iV!=MRData.NO_DATA){
							g.fillRect(bx+cell*co.sbsToCrd[eS][iH][MRCoordinate.CO_HOR],by+cell*co.sbsToCrd[eL][iV][MRCoordinate.CO_VER],cell,cell);
						}
					}
				}
			}
			/*	typẻ𓚊ە\͔p~iitem editƋɒڂ̕\ɂj
			//type
			if(puzzleData.typeExp!=null){
				//hor
				for(int e=1;e<puzzleData.elemNum;e++){
					for(int i=0;i<puzzleData.itemNum;i++){
						paintTypeAnswer(g,bx+cell*co.sbsToCrd[e][i][MRCoordinate.CO_HOR],by-cell,cell,puzzleData.getTypeAnswer(e, i));	//}X̍Wn
					}
				}
				//ver
				for(int i=0;i<puzzleData.itemNum;i++){
					paintTypeAnswer(g,bx-cell,by+cell*i,cell,puzzleData.getTypeAnswer(0, i));
				}
				for(int e=puzzleData.elemNum-1;e>1;e--){
					for(int i=0;i<puzzleData.itemNum;i++){
						paintTypeAnswer(g,bx-cell,by+cell*co.sbsToCrd[e][i][MRCoordinate.CO_VER],cell,puzzleData.getTypeAnswer(e, i));
					}
				}
			}*/
			//	[item edit],[type]
			//hor
			for(int e=1;e<puzzleData.elemNum;e++){
				puzzleData.paintElemAnsHor(g, bx+cell*co.sbsToCrd[e][0][MRCoordinate.CO_HOR], by, cell, e);
			}
			//ver
			puzzleData.paintElemAnsVer(g, bx, by, cell, 0);
			for(int e=puzzleData.elemNum-1;e>1;e--){
				puzzleData.paintElemAnsVer(g, bx, by+cell*co.sbsToCrd[e][0][MRCoordinate.CO_VER], cell, e);
			}
		}
	    //----------------------------
	    g.setColor(Color.black);
		int eH=cell*co.edgeHeight;
		int eW=cell*co.edgeWidth;
		//hor
		g.drawLine(bx-eH,by-1, bx+eW, by-1);
		g.drawLine(bx-eH,by, bx+eW, by);
		for(int e=0;e<puzzleData.elemNum-1;e++) {
			for(int i=1;i<puzzleData.itemNum;i++) {
				g.drawLine(bx,by+cell*(e*puzzleData.itemNum+i), bx+eW-cell*puzzleData.itemNum*e, by+cell*(e*puzzleData.itemNum+i));
			}
			g.drawLine(bx-eH,by+cell*(e+1)*puzzleData.itemNum, bx+eW-cell*puzzleData.itemNum*e, by+cell*(e+1)*puzzleData.itemNum);
			g.drawLine(bx-eH,by+cell*(e+1)*puzzleData.itemNum-1, bx+eW-cell*puzzleData.itemNum*e, by+cell*(e+1)*puzzleData.itemNum-1);
		}
		//ver
		g.drawLine(bx-1,by-eH, bx-1, by+eW);
		g.drawLine(bx,by-eH, bx, by+eW);
		for(int e=0;e<puzzleData.elemNum-1;e++) {
			for(int i=1;i<puzzleData.itemNum;i++) {
				g.drawLine(bx+cell*(e*puzzleData.itemNum+i),by, bx+cell*(e*puzzleData.itemNum+i), by+eW-cell*puzzleData.itemNum*e);
			}
			g.drawLine(bx+cell*(e+1)*puzzleData.itemNum,by-eH, bx+cell*(e+1)*puzzleData.itemNum, by+eW-cell*puzzleData.itemNum*e);
			g.drawLine(bx+cell*(e+1)*puzzleData.itemNum-1,by-eH, bx+cell*(e+1)*puzzleData.itemNum-1, by+eW-cell*puzzleData.itemNum*e);
		}
		//----------------------------vf(element)
		//g.setFont(new Font( null, Font.PLAIN, cell-DEF_FONT_DIFF*2));	//̉𓚂Ŏwς
		//type
		if(puzzleData.typeExp!=null){
			g.drawString(puzzleData.typeExp+"", bx-MRData.getStrSize(puzzleData.typeExp+"",g), by-DEF_FONT_DIFF);	//pւ̑Ή
			g.drawLine(bx, by-cell, bx+eW, by-cell);
			g.drawLine(bx-cell, by, bx-cell, by+eW);
		}
		//hor
		for(int e=1;e<puzzleData.elemNum;e++){
			puzzleData.paintElementHor(g, bx+cell*co.sbsToCrd[e][0][MRCoordinate.CO_HOR], by, cell, e,co.edgeHeight);
		}
		//ver
		puzzleData.paintElementVer(g, bx, by, cell, 0,co.edgeHeight);
		for(int e=puzzleData.elemNum-1;e>1;e--){
			puzzleData.paintElementVer(g, bx, by+cell*co.sbsToCrd[e][0][MRCoordinate.CO_VER], cell, e,co.edgeHeight);
		}
		//----------------------------mark
		g.setFont(new Font( null, Font.BOLD, cell-/*DEF_FONT_DIFF*2*/4));	//
		g.setColor(Color.BLACK);
		for(int w=0;w<co.edgeWidth;w++){
			for(int h=0;h<co.edgeWidth;h++){
				if(co.crdToSbsCent[w][h]!=null){
					//
					switch(puzzleData.getMark(co.crdToSbsCent[w][h])){
					case MRData.MK_CROSS:	//~`
						paintCross(g,bx+cell*w+(cell>>1),by+cell*h+(cell>>1),(cell>>2));
						break;
					case MRData.MK_CIRCLE:	//o`
						g.drawString("", bx+(cell>>3)+cell*w, by-(cell>>3)+cell*(h+1));
						break;
					default:
						//no work
						break;
					}
				}
			}
		}
		//----------------------------J[\
		if(cursorViewFlag){
			//elementI
			if(puzzleMode==MODE_EDIT){
				//
				if(sel!=MRData.NO_DATA) {
					g.setColor(Color.BLUE);
					//hor
					paintElemCursorHor(g,bx,by,cell,sel);
					//ver
					paintElemCursorVer(g,bx,by,cell,sel);
				}
				//dragւ
				if(draged!=null) {
					if(draged[DRG_POS]!=DRG_POS_CENT) {
						if(draged[DRG_EDGE_AFT]!=MRData.NO_DATA) {
							g.setColor(Color.MAGENTA);
							//hor
							paintElemCursorHor(g,bx,by,cell,draged[DRG_EDGE_AFT]);
							//ver
							paintElemCursorVer(g,bx,by,cell,draged[DRG_EDGE_AFT]);
						}
					}
				}
			}
			//}EXʒuJ[\(elementIJ[\\ɕ`)
			if(mouseOn!=null){
				g.setColor(Color.ORANGE);
				//
				if(mouseOn.length==MRCoordinate.SBS_ALL){	//
					int x=co.sbsToCrd[mouseOn[MRCoordinate.SBS_HOR_ELM]][mouseOn[MRCoordinate.SBS_HOR_ITM]][MRCoordinate.CO_HOR];
					int y=co.sbsToCrd[mouseOn[MRCoordinate.SBS_VER_ELM]][mouseOn[MRCoordinate.SBS_VER_ITM]][MRCoordinate.CO_VER];
					//
					g.drawRect(bx+cell*x,by+cell*y,cell,cell);
					g.drawRect(bx+cell*x-1,by+cell*y-1,cell+2,cell+2);
					//hor
					g.drawRect(bx+cell*x,by-cell*co.edgeHeight,cell,cell*co.edgeHeight);
					g.drawRect(bx+cell*x-1,by-cell*co.edgeHeight-1,cell+2,cell*co.edgeHeight+2);
					//ver
					g.drawRect(bx-cell*co.edgeHeight,by+cell*y,cell*co.edgeHeight,cell);
					g.drawRect(bx-cell*co.edgeHeight-1,by+cell*y-1,cell*co.edgeHeight+2,cell+2);
				}else{											//edge
					int e=mouseOn[MRCoordinate.EDG_ELM];
					int i=mouseOn[MRCoordinate.EDG_ITM];
					//hor
					if(co.sbsToCrd[e][i][MRCoordinate.CO_HOR]!=MRData.NO_DATA){
						g.drawRect(bx+cell*co.sbsToCrd[e][i][MRCoordinate.CO_HOR],by-cell*co.edgeHeight,cell,cell*co.edgeHeight);
						g.drawRect(bx+cell*co.sbsToCrd[e][i][MRCoordinate.CO_HOR]-1,by-cell*co.edgeHeight-1,cell+2,cell*co.edgeHeight+2);
					}
					//ver
					if(co.sbsToCrd[e][i][MRCoordinate.CO_VER]!=MRData.NO_DATA){
						g.drawRect(bx-cell*co.edgeHeight,by+cell*co.sbsToCrd[e][i][MRCoordinate.CO_VER],cell*co.edgeHeight,cell);
						g.drawRect(bx-cell*co.edgeHeight-1,by+cell*co.sbsToCrd[e][i][MRCoordinate.CO_VER]-1,cell*co.edgeHeight+2,cell+2);
					}
				}
			}
			//----------------------------G[
			if(errorViewFlag){
				g.setColor(Color.red);
				//
				for(int e=0;e<puzzleData.errors.size();e++){
					MRError er=puzzleData.errors.get(e);
					if(er.agreeMarkError()){
						//ER_CIRCLE_???
						if(er.itemHor==MRData.NO_DATA){	//ver()
							paintErrorCursolVer(g,bx,by,cell,er.elemVer,er.itemVer,er.elemHor,false);
						}else{							//hor(c)
							paintErrorCursolHor(g,bx,by,cell,er.elemHor,er.itemHor,er.elemVer,false);
						}
					}else if(er.agreeMatrixContradiction()){
						//CONTRA_MTR_???
						if(er.elemT==MRData.NO_DATA){	//CONTRA_MTR_TYPE
							//ver
							g.drawOval(bx-cell+1,by+cell*co.sbsToCrd[er.elemSV][er.itemSV][MRCoordinate.CO_HOR]+1,cell-4,cell-4);
							g.drawOval(bx-cell+2,by+cell*co.sbsToCrd[er.elemSV][er.itemSV][MRCoordinate.CO_HOR]+2,cell-4,cell-4);
							//hor
							g.drawOval(bx+cell*co.sbsToCrd[er.elemLH][er.itemLH][MRCoordinate.CO_HOR]+1,by-cell+1,cell-4,cell-4);
							g.drawOval(bx+cell*co.sbsToCrd[er.elemLH][er.itemLH][MRCoordinate.CO_HOR]+2,by-cell+2,cell-4,cell-4);
						}else{							//CONTRA_MTR_MARK
							//
							if(er.elemSV!=MRData.NO_DATA){	//ver,???
								paintErrorCursolVer(g,bx,by,cell,er.elemSV,er.itemSV,er.elemT,true);
								if(er.elemLH!=MRData.NO_DATA){	//ver,hor
									paintErrorCursolHor(g,bx,by,cell,er.elemLH,er.itemLH,er.elemT,true);
								}else{							//ver,ver
									paintErrorCursolVer(g,bx,by,cell,er.elemVer,er.itemVer,er.elemT,true);	//(2ڂ͕ʃG[p̕ϐؗpĂ)
								}
							}else{							//hor,hor
								paintErrorCursolHor(g,bx,by,cell,er.elemLH,er.itemLH,er.elemT,true);
								paintErrorCursolHor(g,bx,by,cell,er.elemHor,er.itemHor,er.elemT,true);	//(2ڂ͕ʃG[p̕ϐؗpĂ)
							}
						}
					}
				}
			}
		}
	}
	/*	typẻ𓚊ە\͔p~iitem editƋɒڂ̕\ɂj
	//typẻ𓚕\
	private void paintTypeAnswer(Graphics g,int bx,int by,int cell,int tp){	//}X̍Wn
		switch(tp){
		case MRData.NO_DATA:	//Ȃ\
			break;
		case 0:	//
			g.fillOval(bx, by, cell/2, cell/2);
			break;
		case 1:	//E
			g.fillOval(bx+cell/2, by, cell/2, cell/2);
			break;
		case 2:	//
			g.fillOval(bx, by+cell/2, cell/2, cell/2);
			break;
		case 3:	//E
			g.fillOval(bx+cell/2, by+cell/2, cell/2, cell/2);
			break;
		}
	}*/
	//~`
	private void paintCross(Graphics g,int dx,int dy,int radius){
		g.drawLine(dx-radius, dy-radius, dx+radius, dy+radius);
		g.drawLine(dx-radius-1, dy-radius, dx+radius-1, dy+radius);
		g.drawLine(dx+radius, dy-radius, dx-radius, dy+radius);
		g.drawLine(dx+radius-1, dy-radius, dx-radius-1, dy+radius);
	}
	//elementJ[\
	private void paintElemCursorHor(Graphics g,int bx,int by,int cell,int e) {
		if(co.sbsToCrd[e][0][MRCoordinate.CO_HOR]!=MRData.NO_DATA) {
			g.drawRect(bx+cell*co.sbsToCrd[e][0][MRCoordinate.CO_HOR], by-cell*co.edgeHeight, cell*puzzleData.itemNum, cell*co.edgeHeight);
			g.drawRect(bx+cell*co.sbsToCrd[e][0][MRCoordinate.CO_HOR]-1, by-cell*co.edgeHeight-1, cell*puzzleData.itemNum+2, cell*co.edgeHeight+2);
		}
	}
	private void paintElemCursorVer(Graphics g,int bx,int by,int cell,int e) {
		if(co.sbsToCrd[e][0][MRCoordinate.CO_VER]!=MRData.NO_DATA) {
			g.drawRect(bx-cell*co.edgeHeight, by+cell*co.sbsToCrd[e][0][MRCoordinate.CO_VER], cell*co.edgeHeight, cell*puzzleData.itemNum);
			g.drawRect(bx-cell*co.edgeHeight-1, by+cell*co.sbsToCrd[e][0][MRCoordinate.CO_VER]-1, cell*co.edgeHeight+2, cell*puzzleData.itemNum+2);
		}
	}
	//
	private void paintErrorCursolVer(Graphics g,int bx,int by,int cell,int eV,int iV,int eH,boolean roundFlag){	//ver()
		if(roundFlag){
			g.drawRoundRect(bx+cell*co.sbsToCrd[eH][0][MRCoordinate.CO_HOR]+1,by+cell*co.sbsToCrd[eV][iV][MRCoordinate.CO_VER]+1,cell*puzzleData.itemNum-2,cell-2,cell,cell);
			g.drawRoundRect(bx+cell*co.sbsToCrd[eH][0][MRCoordinate.CO_HOR]+2,by+cell*co.sbsToCrd[eV][iV][MRCoordinate.CO_VER]+2,cell*puzzleData.itemNum-4,cell-4,cell,cell);
		}else{
			g.drawRect(bx+cell*co.sbsToCrd[eH][0][MRCoordinate.CO_HOR]+1,by+cell*co.sbsToCrd[eV][iV][MRCoordinate.CO_VER]+1,cell*puzzleData.itemNum-2,cell-2);
			g.drawRect(bx+cell*co.sbsToCrd[eH][0][MRCoordinate.CO_HOR]+2,by+cell*co.sbsToCrd[eV][iV][MRCoordinate.CO_VER]+2,cell*puzzleData.itemNum-4,cell-4);
		}
	}
	private void paintErrorCursolHor(Graphics g,int bx,int by,int cell,int eH,int iH,int eV,boolean roundFlag){	//hor(c)
		if(roundFlag){
			g.drawRoundRect(bx+cell*co.sbsToCrd[eH][iH][MRCoordinate.CO_HOR]+1,by+cell*co.sbsToCrd[eV][0][MRCoordinate.CO_VER]+1,cell-2,cell*puzzleData.itemNum-2,cell,cell);
			g.drawRoundRect(bx+cell*co.sbsToCrd[eH][iH][MRCoordinate.CO_HOR]+2,by+cell*co.sbsToCrd[eV][0][MRCoordinate.CO_VER]+2,cell-4,cell*puzzleData.itemNum-4,cell,cell);
		}else{
			g.drawRect(bx+cell*co.sbsToCrd[eH][iH][MRCoordinate.CO_HOR]+1,by+cell*co.sbsToCrd[eV][0][MRCoordinate.CO_VER]+1,cell-2,cell*puzzleData.itemNum-2);
			g.drawRect(bx+cell*co.sbsToCrd[eH][iH][MRCoordinate.CO_HOR]+2,by+cell*co.sbsToCrd[eV][0][MRCoordinate.CO_VER]+2,cell-4,cell*puzzleData.itemNum-4);
		}
	}
	//******************************************************************************************************
	//Z[uE[h
	//------------------------------------------------------------------------------------------------------
	public boolean setLoadString(String[] ld){
		String erMsg=puzzleData.setLoadString(ld);
		if(erMsg==null){
			//
			//e_CAOŕύXɓK
			elemEditDialog=new MRElemEditDialog(frame,puzzleData);	//itemς
			elemAnsDialog.adaptTypeWords();
			answerTableDialog.refreshViewAll();						//element,itemς
			//J[\
			formatCursolPos();
			//Wݒ肵Ȃ
			setCoordinate();
			//
			//fileIOł܂Ƃ߂čŝŁAł͂Ȃ
			//setChanged(false);
			//
			requestFocus();	//return false ȂȂĂ
			//
			return true;
		}else{
			frame.showErrorMessage("CSVt@C̃f[^܂B"+System.getProperty("line.separator")+erMsg);
			//
			requestFocus();	//return false ȂȂĂ
			//
			return false;
		}
	}
	public String getSaveString(boolean solFlag){
		//
		requestFocus();
		//
		//fileIOł܂Ƃ߂čŝŁAł͂Ȃ
		//setChanged(false);
		//
		return puzzleData.getSaveString(solFlag);
	}
	//******************************************************************************************************
	//qgeLXg
	//------------------------------------------------------------------------------------------------------
	public void outputHintText(MRFileIO io){
		io.outputHintText(hintTextDialog);
		//
		requestFocus();
	}
	public void inputHintText(MRFileIO io){
		if(io.inputHintText(hintTextDialog)){
			setChanged(true);
		}
		//
		requestFocus();
	}
	//******************************************************************************************************
	//qg摜
	//------------------------------------------------------------------------------------------------------
	public void outputHintImage(MRFileIO io){
		io.outputHintImage(hintImageDialog);
		//
		requestFocus();
	}
	public void inputHintImage(MRFileIO io){
		if(io.inputHintImage(hintImageDialog)){
			setChanged(true);
		}
		//
		requestFocus();
	}
	public void deleteHintImage(){
		hintImageDialog.deleteImage();
		//
		setChanged(true);
		requestFocus();
	}
	//******************************************************************************************************
	//_CAO\
	//------------------------------------------------------------------------------------------------------
	public void showHintTextDialog(boolean st){
		hintTextDialog.setVisible(st);
		requestFocus();
	}
	public void showHintImageDialog(boolean st){
		hintImageDialog.setVisible(st);
		requestFocus();
	}
	public void showAnswerTableDialog(boolean st){
		answerTableDialog.setVisible(st);
		requestFocus();
	}
	//******************************************************************************************************
	//}EXCxg
	//------------------------------------------------------------------------------------------------------
	//elementւ
	public void mouseReleased(MouseEvent e) {
		//
		if(draged!=null) {
			if(draged[DRG_POS]!=DRG_POS_CENT) {					//edgë̗ŁA
				if(puzzleMode==MODE_EDIT){						//edit[hŁA
					if(draged[DRG_EDGE_AFT]!=MRData.NO_DATA) {	//悪܂Ă΁Aelement̓ւ
						//
						if(!puzzleData.checkAnswerTableReplace(draged[DRG_EDGE_BFR],draged[DRG_EDGE_AFT])){
							int ret=JOptionPane.showConfirmDialog(frame,"𓚕\ɂăf[^ێłȂ߁A\܂B"+System.getProperty("line.separator")+"܂H",
									"mF",JOptionPane.YES_NO_OPTION,JOptionPane.WARNING_MESSAGE);
							if(ret!=JOptionPane.YES_OPTION){
								//sA㏈ďI
								draged=null;
								repaint();
								return;
							}
						}
						//ւs
						puzzleData.replaceElem(draged[DRG_EDGE_BFR],draged[DRG_EDGE_AFT]);
						answerTableDialog.refreshViewAll();		//𓚕\̕Wς
						//
						setChanged(true);
						//
						sel=draged[DRG_EDGE_AFT];
					}
				}
			}
			//
			draged=null;
		}
		//
		repaint();
		getAnsTablePanel().repaint();
	}
	//no work
	public void mouseEntered(MouseEvent e) {
	}
	//dragZbg
	public void mouseExited(MouseEvent e) {
		//
		draged=null;
		//
		repaint();
	}
	//dragJn
	public void mousePressed(MouseEvent e) {
		//}Xʒuiedge͕Acenter0ȍ~j
		int x=(e.getX()>baseX)?(e.getX()-baseX)/cellSize:(e.getX()-cellSize-baseX)/cellSize;
		int y=(e.getY()>baseY)?(e.getY()-baseY)/cellSize:(e.getY()-cellSize-baseY)/cellSize;
		//
		int[] sbs=co.getSubstance(x, y);
		if(sbs!=null) {
			if(sbs.length==MRCoordinate.EDG_ALL) {	//edge(element)ȂAedit[helementւpdragJn
				if(puzzleMode==MODE_EDIT) {
					sel=sbs[MRCoordinate.EDG_ELM];
					//
					draged=new int[] {co.dragPos,sel,MRData.NO_DATA};
				}
			}else {									//center(mark)ȂA[hɂ炸mark͗pdragJn
				if(e.getModifiers()==MouseEvent.META_MASK || e.isShiftDown()){	//E{^܂̓VtgL[
					puzzleData.setCross(sbs);
				}else {
					puzzleData.setCircle(sbs,autoXAddFlag,autoXDelFlag);
				}
				setChanged(true);
				//
				draged=new int[] {DRG_POS_CENT,x,y};
			}
		}else {
			sel=MRData.NO_DATA;
			//draged=null̂܂
		}
		//
		repaint();
		//
	}
	//̓_CAO\
	public void mouseClicked(MouseEvent e) {
		//}Xʒuiedge͕Acenter0ȍ~j
		int x=(e.getX()>baseX)?(e.getX()-baseX)/cellSize:(e.getX()-cellSize-baseX)/cellSize;
		int y=(e.getY()>baseY)?(e.getY()-baseY)/cellSize:(e.getY()-cellSize-baseY)/cellSize;
		//
		int[] sbs=co.getSubstance(x, y);
		if(sbs!=null && sbs.length==MRCoordinate.EDG_ALL) {
			//
			if(e.getModifiers()==MouseEvent.META_MASK || e.isShiftDown()){	//E{^܂̓VtgL[
				if(puzzleMode==MODE_EDIT){		//edit[hȂAelemEditDialog\
					elemEditDialog.setCurrentData(sbs[MRCoordinate.EDG_ELM]);
					elemEditDialog.setVisible(true);
				}
			}else{								//item𓚓͂ȂAelemAnsDialog\
				if(puzzleData.checkElemAnswer(sbs[MRCoordinate.EDG_ELM])){
					elemAnsDialog.setCurrentData(sbs);
					elemAnsDialog.setVisible(true);
				}
			}
			//
			requestFocus();
		}
	}
	//dragis
	public void mouseDragged(MouseEvent e) {
		//}Xʒuiedge͕Acenter0ȍ~j
		int x=(e.getX()>baseX)?(e.getX()-baseX)/cellSize:(e.getX()-cellSize-baseX)/cellSize;
		int y=(e.getY()>baseY)?(e.getY()-baseY)/cellSize:(e.getY()-cellSize-baseY)/cellSize;
		//
		if(draged!=null){
			int[] sbs=co.getSubstance(x, y);
			if(sbs!=null){
				if(sbs.length==MRCoordinate.EDG_ALL) {	//edge(element)
					if(puzzleMode==MODE_EDIT) {			//ҏW[ĥ
						if(co.dragPos!=draged[DRG_POS]) {	//̈ÖړȂ烊Zbg
							draged=null;
						}else {								//̈Ȃelement̓ւ`FbN
							if(draged[DRG_EDGE_BFR]!=sbs[MRCoordinate.EDG_ELM]) {
								draged[DRG_EDGE_AFT]=sbs[MRCoordinate.EDG_ELM];
							}else {
								draged[DRG_EDGE_AFT]=MRData.NO_DATA;
							}
						}
					}
				}else {									//center(mark)
					if(draged[DRG_POS]!=DRG_POS_CENT) {		//̈ÖړȂ烊Zbg
						draged=null;
					}else {									//̈ȂuXv̓̓`FbN
						if(e.getModifiers()==MouseEvent.META_MASK || e.isShiftDown()){	//E{^܂̓VtgL[
							if(draged[DRG_CENT_X]!=x || draged[DRG_CENT_Y]!=y) {
								puzzleData.setCross(sbs);
								setChanged(true);
								//
								draged[DRG_CENT_X]=x;
								draged[DRG_CENT_Y]=y;
							}			//}ẌړȂdȂ
						}				//uovdragŘA`悵Ȃ
					}
				}
			}else{											//̈OɏoȂ烊Zbg
				draged=null;
			}
		}
		//ĕ`
		repaint();
	}
	//J[\ړ
	public void mouseMoved(MouseEvent e) {
		//}Xʒuiedge͕Acenter0ȍ~j
		int x=(e.getX()>baseX)?(e.getX()-baseX)/cellSize:(e.getX()-cellSize-baseX)/cellSize;
		int y=(e.getY()>baseY)?(e.getY()-baseY)/cellSize:(e.getY()-cellSize-baseY)/cellSize;
		//
		mouseOn=co.getSubstance(x, y);
		//ĕ`
		repaint();
	}
	//******************************************************************************************************
	//L[Cxg
	//------------------------------------------------------------------------------------------------------
	public void keyTyped(KeyEvent e) {
	}
	public void keyReleased(KeyEvent e) {
	}
	public void keyPressed(KeyEvent e) {
		//
		switch(e.getKeyCode()){
		case KeyEvent.VK_ENTER:		//ENTER
			if(puzzleMode==MODE_EDIT) {	//edit[hȂAelementIJ[\AelemEditDialog\
				if(sel!=MRData.NO_DATA) {
					elemEditDialog.setCurrentData(sel);
					elemEditDialog.setVisible(true);
				}
			}else {						//play[hȂA}EXʒuJ[\Amark
				if(mouseOn!=null && mouseOn.length==MRCoordinate.SBS_ALL) {
					if(e.isShiftDown()) {
						puzzleData.setCross(mouseOn);
					}else {
						puzzleData.setCircle(mouseOn,autoXAddFlag,autoXDelFlag);
					}
					setChanged(true);
				}
			}
			break;
		case KeyEvent.VK_UP:		//
			if(puzzleMode==MODE_EDIT) {	//edit[hȂAelementIJ[\̈ړ
				moveSelVer(-1);
			}else {						//play[hȂA}EXʒuJ[\̈ړ
				moveMouseOn(0,-1);
			}
			break;
		case KeyEvent.VK_DOWN:		//
			if(puzzleMode==MODE_EDIT) {	//edit[hȂAelementIJ[\̈ړ
				moveSelVer(1);
			}else {						//play[hȂA}EXʒuJ[\̈ړ
				moveMouseOn(0,1);
			}
			break;
		case KeyEvent.VK_RIGHT:		//E
			if(puzzleMode==MODE_EDIT) {	//edit[hȂAelementIJ[\̈ړ
				moveSelHor(1);
			}else {						//play[hȂA}EXʒuJ[\̈ړ
				moveMouseOn(1,0);
			}
			break;
		case KeyEvent.VK_LEFT:		//
			if(puzzleMode==MODE_EDIT) {	//edit[hȂAelementIJ[\̈ړ
				moveSelHor(-1);
			}else {						//play[hȂA}EXʒuJ[\̈ړ
				moveMouseOn(-1,0);
			}
			break;
		default:
		}
		repaint();	//ĕ`
	}
	//elementIJ[\̈ړ
	private void moveSelHor(int d) {
		if(sel==MRData.NO_DATA || co.sbsToCrd[sel][0][MRCoordinate.CO_HOR]==MRData.NO_DATA) {
			if(d>0) {	//horIŉEړ
				sel=1;
			}else {		//horIōړ
				sel=puzzleData.elemNum-1;
			}
		}else {	//horI
			int x=co.sbsToCrd[sel][0][MRCoordinate.CO_HOR]+d*puzzleData.itemNum;
			if(x<0 || x>=co.edgeWidth) {	//ړ悪[o
				sel=MRData.NO_DATA;
			}else {							//ړ͈͓
				sel=co.crdToSbsEdge[MRCoordinate.CO_HOR][x][MRCoordinate.EDG_ELM];
			}
		}
	}
	private void moveSelVer(int d) {
		if(sel==MRData.NO_DATA || co.sbsToCrd[sel][0][MRCoordinate.CO_VER]==MRData.NO_DATA) {
			if(d>0) {	//verIŉړ
				sel=0;
			}else {		//verIŏړ
				sel=2;
			}
		}else {	//verI
			int y=co.sbsToCrd[sel][0][MRCoordinate.CO_VER]+d*puzzleData.itemNum;
			if(y<0 || y>=co.edgeWidth) {	//ړ悪[o
				sel=MRData.NO_DATA;
			}else {							//ړ͈͓
				sel=co.crdToSbsEdge[MRCoordinate.CO_VER][y][MRCoordinate.EDG_ELM];
			}
		}
	}
	//}EXʒuJ[\̈ړ
	private void moveMouseOn(int dx,int dy) {	//(dx,dyǂ炩+1-1A0)
		if(mouseOn==null) {									//͈͊O(o邾oIɖȂʒucenterɏo)
			if(dy>0 || dx>0) {
				mouseOn=co.getSubstance(0, 0);
			}else if(dx<0) {
				mouseOn=co.getSubstance(co.edgeWidth-1, 0);
			}else if(dy<0){
				mouseOn=co.getSubstance(0, co.edgeWidth-1);
			}
		}else if(mouseOn.length==MRCoordinate.EDG_ALL) {	//edge(o邾oIɖȂʒucenterɏo)
			int x=co.sbsToCrd[mouseOn[MRCoordinate.EDG_ELM]][mouseOn[MRCoordinate.EDG_ITM]][MRCoordinate.CO_HOR];
			int y=co.sbsToCrd[mouseOn[MRCoordinate.EDG_ELM]][mouseOn[MRCoordinate.EDG_ITM]][MRCoordinate.CO_VER];
			if(x==MRData.NO_DATA) {		//x==NO_DATA,y!=NO_DATA -> element0
				if(dx>0) {
					mouseOn=co.getSubstance(0, y/*+dy(=0)*/);
				}else if(dx<0) {
					mouseOn=co.getSubstance(co.edgeWidth-1, y/*+dy(=0)*/);
				}else {
					int[] tmpMouseOn=co.getSubstance(0, y+dy);
					if(tmpMouseOn!=null && tmpMouseOn.length!=MRCoordinate.EDG_ALL) {
						mouseOn=tmpMouseOn;
					}else {
						mouseOn=co.getSubstance(0, y);
					}
				}
			}else {
				if(y==MRData.NO_DATA) {	//x!=NO_DATA,y==NO_DATA -> element1
					if(dy>0) {
						mouseOn=co.getSubstance(x/*+dx(=0)*/, 0);
					}else if(dy<0) {
						mouseOn=co.getSubstance(x/*+dx(=0)*/, co.edgeWidth-1);
					}else {
						int[] tmpMouseOn=co.getSubstance(x+dx, 0);
						if(tmpMouseOn!=null && tmpMouseOn.length!=MRCoordinate.EDG_ALL) {
							mouseOn=tmpMouseOn;
						}else {
							mouseOn=co.getSubstance(x, 0);
						}
					}
				}else {					//x!=NO_DATA,y!=NO_DATA -> element2ȍ~
					if(dy>0) {
						mouseOn=co.getSubstance(x/*+dx(=0)*/, 0);
					}else if(dy<0){
						mouseOn=co.getSubstance(x/*+dx(=0)*/, y-(y%puzzleData.itemNum)-1);
					}else {
						if(dx>0) {
							mouseOn=co.getSubstance(0, y/*+dy(=0)*/);
						}else {	//dx<0
							mouseOn=co.getSubstance(x-(x%puzzleData.itemNum)-1, y/*+dy(=0)*/);
						}
					}
				}
			}
		}else {												//center(͈͊Oɂ͏oɈړ)
			int x=co.sbsToCrd[mouseOn[MRCoordinate.SBS_HOR_ELM]][mouseOn[MRCoordinate.SBS_HOR_ITM]][MRCoordinate.CO_HOR];
			int y=co.sbsToCrd[mouseOn[MRCoordinate.SBS_VER_ELM]][mouseOn[MRCoordinate.SBS_VER_ITM]][MRCoordinate.CO_VER];
			int[] tmpMouseOn=co.getSubstance(x+dx, y+dy);						//ړ悪
			if(tmpMouseOn!=null && tmpMouseOn.length!=MRCoordinate.EDG_ALL) {	//͈͓Ȃړ
				mouseOn=tmpMouseOn;
			}																	//͈͊OȂړȂ
		}
	}
	//******************************************************************************************************
	//	R|[lgCxgitB[h̑傫ύX擾j
	//------------------------------------------------------------------------------------------------------
	public void componentResized(ComponentEvent e) {
		setPaintBasePoint();	//pl̃TCYςΕ`挴_Đݒ
	}
	public void componentMoved(ComponentEvent e) {
	}
	public void componentShown(ComponentEvent e) {
	}
	public void componentHidden(ComponentEvent e) {
	}

}
